(SETQ TOPLOOPNAME!* "")

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (C) 1992,1994,1996,1998,2001,2002 Joergen Backelin
%%
%% Bergman is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY.  No author or distributor
%% accepts responsibility to anyone for the consequences of using it
%% or for whether it serves any particular purpose or works at all,
%% unless (s)he says so in writing.  Refer to the Bergman General
%% Public License for full details.

%% Everyone is granted permission to copy, modify and redistribute
%% bergman, but only under the conditions described in the
%% Bergman General Public License.   A copy of this license is
%% supposed to have been given to you along with bergman so you
%% can know your rights and responsibilities.  It should be in a
%% file named copyright.  Among other things, the copyright notice
%% and this notice must be preserved on all copies.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%        CHANGES:

%  Added hscomm.fas after JoeB. /KAE 2002-10-15 09:15:52 

%  Added DEGREVLEXIFY, SETNORESOLUTION. /JoeB 2002-06-26 -- 07-12

%  Added SETRINGOBJECT. /JoeB 2001-08-03

%  PBSERIESFILE!* removed; !*PBSisLoaded --> !*HSisLoaded
% /JoeB 1999-11-04

%  GETD --> DEFP./JoeB 1999-07-02

%  Re-declared HISTORYLIST!*. Removed ALGOUTMODE./JoeB 1999-06-29

%  Declared more fluids and globals. Added MODULESHSERIESFILE!*.
% /JoeB 1999-06-26

%  Moved MODULEHSERIES to topproc.sl. Added GLOBALs and FLUIDs.
% /Joeb 1998-10-22 -- 10-23

%  Added HSERIESFILE!*, !*HSisLoaded, preliminary version of
% MODULEHSERIES/JoeB 1998-02-28.

%  Added !*Bignums!&Are!&Loaded flag setting in Reduce mode
% /JoeB 1998-02-11.

%  Moved global flag resettings towards end of file/JoeB 1997-01-07.

%  Adopted to `kzz like' architecture handling/JoeB 1996-11-27.

% 1996-08-14: Since "full" now is split into two, both must be loaded.

% To begin with, only the most raw Standard Lisp procedures are
% expexted. Here follows three LAPINs (reading and evaling
% but suppressing printing from entire files).

  (LOAD "versmacr.sl")
  (LOAD "specmode.sl")
  (LOAD "specmacr.sl")
  (COND ((PROBE-FILE "specbrg1.sl") (LOAD "specbrg1.sl"))
        (T NIL))

(LOAD (MKBMPATHEXPAND "$bmload/slext.fas"))
(LOAD (MKBMPATHEXPAND "$bmload/speclisp.fas"))


(C-OFF RAISE)

(GLOBAL '(SPairs cSPairs GBasis cGBasis InPols cInPols MAXDEG
          BigNumbFile InumModLimit LogModLimit EMBDIM MAOaux
          !*Bignums!&Are!&Loaded HSERIESFILE!*
          !*HSisLoaded MONLIST !&!*InnerEmbDim!&!*
          ReclaimList NOOFSPOLCALCS NOOFNILREDUCTIONS !*CUSTSHOW
          !*PBSERIES !*SAVERECVALUES !*POSLEADCOEFFS
          !*IMMEDIATEFULLREDUCTION !*NOBIGNUM BMVERSIONSTRING)
)

(FLUID '(HISTORYLIST!* oldoutfi PBoutfi Houtfi oldded !*OBSOLETENAMESINFORM))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%14.08.96 Svetlana Cojocaru, Victor Ufnarovski.
%Respecting the restriction on the FASLOUT output file length (no more
%than 64K) the "full" module was divided into two parts : "full" and "full1".
%It is necessary to load both of them.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;(LOAD "full" "full1" "auxil")                % Main procedures, and extras.

;full
(LOAD (MKBMPATHEXPAND "$bmload/modes.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/main.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/inout.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/monom.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/ncmonom.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/normwd.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/reclaim.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/polynom.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/reduct.fas"))

;full1
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/coeff.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/char0.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/strategy.fas"))

;auxil
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/auxil.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/homog.fas"))

(COND ((SETQ temp
         (PROBE-FILE (MKBMPATHEXPAND "$bmload/alg2lsp.fas"))) (LOAD temp))
      (T (PRIN2 "*** alg2lsp binary does not exists") (TERPRI)))


% User-friendly (?) top-of-the-top:
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmaux/topproc.sl"))


;stg
(LOAD (MKBMPATHEXPAND "$bmload/checkstg.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/accproc.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/subsproc.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/stg.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/monomstg.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/bind.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/write.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/ideal.fas"))
(RECLAIM)

;hseries
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/hseries.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/hscomm.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/modinout.fas"))
(C-OFF RAISE)
(LOAD (MKBMPATHEXPAND "$bmload/sermul.fas"))

(ON |HSysLoaded|)

;anick
(OFF |AnickIsLoaded|)


% Set-up dependent extra loads, et cetera:

(COND ((PROBE-FILE "specbrg2.sl") (LOAD "specbrg2.sl")))

(C-OFF RAISE)


% Here is a (hopefully complete) list of file names and file name suffixes
% used by bergman automatic file reading commands. PSL suffixes are not
% added.
%  Some names are identifiers in capitals; these are translated to lower
% case letters by the PSL procedure LOAD.


;(SETQ PBSERIESFILE!* (MKBMPATHEXPAND "$bmload/pbseries.fas"))
(SETQ HSERIESFILE!* (MKBMPATHEXPAND "$bmexe/hseries"))
(SETQ MODULESHSERIESFILE!* (MKBMPATHEXPAND "$bmsrc/modhser.sl"))

(SETQ ORDINARYMODULARFILE!* (MKBMPATHEXPAND "$bmsrc/odd.sl"))
(SETQ LOGEXPMODULARFILE!* (MKBMPATHEXPAND "$bmsrc/logodd.sl"))
(SETQ MODULO2FILE!* (MKBMPATHEXPAND "$bmsrc/char2.sl"))

(SETQ PrimeFilePreAmble (MKBMPATHEXPAND "$bmdomains/P"))

% For dynmktab.sl (Dynamic making of 'modular logarithm' tables).
(SETQ !&!*PRIMAUXFILE (MKBMPATHEXPAND "$bmload/primaux.fas"))
(SETQ !&!*PRLFILE (MKBMPATHEXPAND "$bmdomains/PRL"))
(SETQ !&!*DYNAMICMAKELOGTABLEFILE
      (MKBMPATHEXPAND "$bmdomains/dynmktab.sl"))

% The following SHOULD BE SET ARCHITECTURE DEPENDENTLY!
% Regard these settings as default values only.
(SETQ InumModLimit (SUB1 (EXPT 2 15)))
(SETQ InumLogModLimit (SUB1 (EXPT 2 30)))
(SETQ LogModLimit (EXPT 2 20))

% Default SAWS files setting (which may be overruled by assigning
% other values before or after the file loading):
% (SETQ INITPRIORITYSTART 0)
% (SETQ INITPRIORITYSTEPLENGTH 32)
% (SETQ REPRIORITYSTEPLENGTH 16)

% Some flags and modes, default settings/initiations.
% (May be changed by "local.sl" settings, if you wish.)

(ON SAVERECVALUES) (ON POSLEADCOEFFS)
(SETRINGOBJECT) 
% KAE 2002-09-01 13:52:09 added SETNORESOLUTION and DEGREVLEXIFY after JoeB
(SETNORESOLUTION)
(DEGREVLEXIFY)
(COMMIFY)
(RESTORECHAR0)
(SETCASESENSALGIN T)

(ON IMMEDIATEFULLREDUCTION)
(ON STANDARDANICKMODES) 

(PROGN (RDS (OPEN (MKBMPATHEXPAND "$bmauxil/fullversion") 'INPUT))
       (SETQ BMVERSIONSTRING (READ))
       (CLOSE (RDS NIL))) 

% Last chances of interactions;
% e.g., set-up specific flag and mode settings:

(COND ((PROBE-FILE "specbrg3.sl") (LOAD "specbrg3.sl")))


% For possible future use. Patching should be done `globally'.

(COND ((PROBE-FILE (MKBMPATHEXPAND "$bmroot/patches.sl"))
       (M-LAPIN (MKBMPATHEXPAND "$bmroot/patches.sl"))))


% For local modifications:

(COND ((PROBE-FILE "local.sl") (LOAD "local.sl")))


% Restore normal global flags settings.

(C-ON RAISE)
(ON USERMODE) (ON REDEFMSG)
