@echo off
if -%1- == -- goto usage 

set clisp=%1\lisp.exe
rem I've got clisp in the var clisp
rem I need the var clispb: working clisp which uses the memory file
set clispb=%clisp% -M %1\lispinit.mem -m 10M

%clispb% prelisp.lsp
if ERRORLEVEL 1 goto Badlisp

copy getbmroot_0.bat ..\..\..\getbmroot.bat > nul
cd ..\..\..
cd >>getbmroot.bat
call getbmroot.bat
del getbmroot.bat
rem Now I have bmroot (Bergman root)

set bmsrc=%bmroot%\src
set bmdomains=%bmroot%\domains
set bmaux=%bmroot%\auxil
set bmauxil=%bmroot%\auxil
set bmload=%bmroot%\lap\clisp\win9598nt
set bmexe=%bmroot%\bin\clisp\win9598nt

copy scripts\clisp\win9598nt\getbmvers_0.bat getbmvers.bat >nul
type auxil\version >>getbmvers.bat
call getbmvers.bat
del getbmvers.bat

set clsrc=%bmroot%\scripts\clisp\win9598nt
set clbin=%bmroot%\bin\clisp\win9598nt
set clasrc=%bmaux%\clisp

echo Starting the installation...
echo Using Bergman root [%bmroot%]
echo Using CLISP [%clispb%]

cd bin\clisp\win9598nt

echo Copying files...

rem Copying necessary files
copy %clsrc%\setcmp1.sl speccmp1.sl > nul
copy %clsrc%\setcmp2.sl speccmp2.sl > nul
copy %clsrc%\setlisp.sl speclisp.sl > nul
copy %clsrc%\setmacr.sl specmacr.sl > nul
copy %clsrc%\setmode.sl specmode.sl > nul
copy %clasrc%\versmacr.sl > nul
copy %clasrc%\switches.lsp > nul
copy %clasrc%\environ.lsp > nul
copy %clasrc%\environ0.lsp > nul
copy %clasrc%\bmtop-cl.lsp > nul
copy %clasrc%\compile-cl.lsp > nul
copy %clasrc%\compan.lsp > nul
copy %bmsrc%\alg2lsp.sl > nul
copy %clasrc%\anick > nul
copy %clasrc%\hseries > nul
copy %clsrc%\bergman.pif > nul

copy %clsrc%\checkerr.lsp > nul

echo Creating fullversion...

rem Creating fullversion
del %bmauxil%\fullversion > nul
copy /b %bmauxil%\fvstart + %bmauxil%\version + %bmauxil%\fvend %bmauxil%\fullversion > nul

echo Deleting old binaries...

rem Deleting old binaries
del %bmload%\*.fas > nul
del %bmload%\*.lib > nul
del %bmexe%\lispinit.mem > nul

echo Compiling SL translation package...

rem Compiling environ
echo (compile-file "environ0.lsp") >_tt_.lsp
echo (quit) >>_tt_.lsp
%clispb%  <_tt_.lsp > bergman.log
if ERRORLEVEL 1 echo bad
del _tt_.lsp
echo (LOAD "environ0.fas") >_tt_.lsp
echo (IN-PACKAGE "ENVIRON0") >> _tt_.lsp
echo (compile-file "environ.lsp") >>_tt_.lsp
echo (quit) >>_tt_.lsp
%clispb%  <_tt_.lsp >> bergman.log
if ERRORLEVEL 1 echo bad
del _tt_.lsp

echo Compiling Bergman...

rem Compiling Bergman
echo (LOAD "environ0.fas") > _tt_.lsp
echo (IN-PACKAGE "ENVIRON0") >> _tt_.lsp
echo (LOAD "environ.fas") >> _tt_.lsp
echo (SETQ *COMPILE-WARNINGS* NIL) >> _tt_.lsp
echo (IN-PACKAGE "Bergman") >> _tt_.lsp
echo (LOAD "compile-cl.lsp") >> _tt_.lsp
echo (QUIT) >>_tt_.lsp
%clispb%  <_tt_.lsp >> bergman.log
del _tt_.lsp

echo Compiling Anick...

rem Compiling anick
echo (LOAD "environ0.fas") > _tt_.lsp
echo (IN-PACKAGE "ENVIRON0") >> _tt_.lsp
echo (LOAD "environ.fas") >> _tt_.lsp
echo (SETQ *COMPILE-WARNINGS* NIL) >> _tt_.lsp
echo (IN-PACKAGE "Bergman") >> _tt_.lsp
echo (LOAD "compan.lsp") >> _tt_.lsp
echo (SETQ *LOAD-VERBOSE* NIL) >> _tt_.lsp
echo (GC) >> _tt_.lsp
echo (QUIT) >>_tt_.lsp
%clispb%  <_tt_.lsp >> bergman.log
del _tt_.lsp

echo Generating the image...

rem Generating image
echo (LOAD "environ0.fas") > _tt_.lsp
echo (IN-PACKAGE "ENVIRON0") >> _tt_.lsp
echo (LOAD "environ.fas") >> _tt_.lsp
echo (SETQ *COMPILE-WARNINGS* NIL) >> _tt_.lsp
echo (IN-PACKAGE "Bergman") >> _tt_.lsp
echo (SETQ *BMVersion* %bmvers%) >> _tt_.lsp
echo (LOAD "bmtop-cl.lsp") >> _tt_.lsp
echo (SETQ *LOAD-VERBOSE* NIL) >> _tt_.lsp
echo (GC) >> _tt_.lsp
echo (IN-PACKAGE "Bergman") >> _tt_.lsp
echo (SAVEINITMEM "lispinit.mem" :INIT-FUNCTION #'BERGMAN-PACKAGE::BANNER-OUTPUT) >> _tt_.lsp
echo (QUIT) >>_tt_.lsp
%clispb%  <_tt_.lsp >> bergman.log
del _tt_.lsp

%clispb% checkerr.lsp 
if ERRORLEVEL 1 echo There are errors. Please check the log file

echo @echo off> bergman.bat
echo set bmroot=%bmroot%>> bergman.bat
echo set bmsrc=%%bmroot%%\src>> bergman.bat
echo set bmdomains=%%bmroot%%\domains>> bergman.bat
echo set bmaux=%%bmroot%%\auxil>> bergman.bat
echo set bmauxil=%%bmroot%%\auxil>> bergman.bat
echo set bmload=%%bmroot%%\lap\clisp\win9598nt>> bergman.bat
echo set bmexe=%%bmroot%%\bin\clisp\win9598nt>> bergman.bat
echo set bmvers=%bmvers%>> bergman.bat
echo %clisp% -M %bmroot%\bin\clisp\win9598nt\lispinit.mem %%1 %%2 %%3 %%4 %%5 %%6 %%7 %%8 %%9 >> bergman.bat

copy %bmroot%\logs\clwin9598nt.log %bmroot%\logs\clwin9598nt.old > nul
move bergman.log %bmroot%\logs\clwin9598nt.log > nul

del *.sl
del *.lsp
del *.fas
del *.lib

echo Install finished, check log file
goto end
:usage
echo Usage %0 CLISP-dir
goto end

:Badlisp
echo You have an old lisp version 
:end
