%  Mode changing procedures.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (C) 1992,1994,1996,1997,1999,2002 Joergen Backelin
%%
%% Bergman is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY.  No author or distributor
%% accepts responsibility to anyone for the consequences of using it
%% or for whether it serves any particular purpose or works at all,
%% unless (s)he says so in writing.  Refer to the Bergman General
%% Public License for full details.

%% Everyone is granted permission to copy, modify and redistribute
%% bergman, but only under the conditions described in the
%% Bergman General Public License.   A copy of this license is
%% supposed to have been given to you along with bergman so you
%% can know your rights and responsibilities.  It should be in a
%% file named copyright.  Among other things, the copyright notice
%% and this notice must be preserved on all copies.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%	Created 1997-09-17 from part of old main.sl.
%	All top level mode changers should be collected here.

%   CHANGES:

%  Adding AUTO ADDRELATIONS handling./JoeB 2002-10-10

%  Tried to fix the GLOBAL declaration of the switches corresponding
% to the elements in !#!&UsrFlags!#!*. Avoided re-definitions of
% ExtractCurrentModes and of PRINTSETUP./JoeB 2002-10-09

%  Added resolution calculations type modes./JoeB 2002-07-12

%  Added HSeriesOrdWeights,HSeriesAltWeights.
%  Spread the use of OneOfAskRead, but removed !*!&HelpList!#.
% /JoeB 2002-07-06 -- 09

%  PMon2HlbMon --> commPMon2HlbMon/JoeB 2002-06-16, 2002-06-26

%  Added a module type.
% JoeB 2001-08-03


%  Changed RestoreMode and !#!&ListOfModes!#!*, by introducing
% extra FUNCTION quotings within the !#!&ListOfModes!#!* items,
% countered by an extra EVAL before APPLYing the function within
% RestoreMode. (Thus, the new `feature' of clisp APPLY, i.e.,
% not to accept pure LAMBDA expressions as functions, is
% circumvened.)/JoeB,SV 2000-08-08

%  Introduced IOWeights2Weights, Weights2IOWeights.  Made
% !*!&WeightsList!# !*!&WeightsDPList!# FLUID (not GLOBAL).
% Improved argument check and handling for SETWEIGHTS.
% Corrected GETSETUP handling of HSERIESLIMITATIONS.
% Added !#NoAListWarning!&, CheckWarning, and !*!#CheckFailInform,
% and started to make CHECKSETUP operating.  Brought PMon2HlbMon
% here. Corrected pp order changers by removing the prefix comm-
% from LCorOUT.

%  Combined setting and globalising !#!&UsrFlags!#!* (in order for
% the common lisp compiler to be able to handle it)./JoeB 1999-11-19


%  Removed !*PBSisLoaded, PBSERIESFILE!*./JoeB 1999-11-04

%  Corrected SETMAXDEG./JoeB 1999-07-08

%  Made ListSwitch call APPENDLCHARTOID. Added CL!-SPECIFIC
% PRINTSETUP. GETD --> DEFP. /JoeB 1999-07-02

%  Added 12 preliminary GET... and 12 SET..., in order to avoid
% (documented) switches for mode changing purposes./JoeB 1999-07-01

%  Replaced explicit ALGOUTMODE access by calls to SETALGOUTMODE and
% GETALGOUTMODE. Added QuizIds!* and OneOfAskRead./JoeB 1999-06-29

%  Added extraction and restoration of Hilbert series minima.
% /JoeB 1999-06-26

%  Added ANICK mode. Changed ExtractCurrentModes and ExtractMode,
% so that they should handle some mode extractor being undefined
% gracefully./JoeB 1998-11-07

%  Introduced the type modestate./JoeB 1998-11-04

%  Added <GET,SET><MIN,MAX>DEG./JoeB 1998-11-03

%  REVLEXIFY --> DEGREVLEXIFY, but old name retained as an (obsolete)
% alias. Corrected some messages./JoeB 1998-10-22 -- 10-23



% Import: PROMPTREAD.

% Export: OneOfAskRead, AUTOADDRELATIONSTATE, MAYBEAUTOADDRELATIONS;
%	  QuizIds!*.

% Available: DEGLEXIFY, PURELEXIFY, DEGREVLEXIFY, COMMIFY,
%	     NONCOMMIFY, NOEXPTSPRINTMODE, EXPTSPRINTMODE,
%	     DENSECONTENTS, SPARSECONTENTS,
%	     CLEARWEIGHTS, SETWEIGHTS, GETWEIGHTS, GETWEIGHTDPS,
%	     PRINTWEIGHTS, SETOBJECTTYPE, GETOBJECTTYPE,
%	     SETMODULEOBJECT, SETRINGOBJECT, MODULEOBJECT,
%	     AUTOADDRELATIONS, NOAUTOADDRELATIONS,
%	     CANCELAUTOADDRELATIONSSETTINGS, SETAUTOADDRELATIONSSTATE

(OFF RAISE)

(GLOBAL '(!*SAVEDEGREE !*PBSERIES !*IMMEDIATEFULLREDUCTION
	  !*NONCOMMUTATIVE !*MONOIDAL !*IMMEDIATECRIT MINDEG MAXDEG
	  !*MODLOGARITHMS !*!&NoRaiseAlgInp!# !*!&!#PrintNoExpts!*
	  !*!&ResTyp!# !*!&ResolutionTypes!# !*DEGREEPRINTOUTPUT
	  commMONORDER noncommMONORDER !*!&CommMonOrders!#
	  !*!&NonCommMonOrders!# Modulus !*CUSTSTRATEGY
	  !*OLDPRINTMODES1 !#!&ListOfModes!#!* !#!&ObjectType
	  !#!&UsrFlags!#!* !*OLDSERIESMODES1 !*HSisLoaded
	  HSERIESFILE!* QuizIds!* !*CUSTSHOW !*CUSTSTRATEGY
	  !*DYNAMICLOGTABLES !*HOMOGENISED !*IMMEDIATERECDEFINE
	  !*NOBIGNUM !*REDUCTIVITY !*SAVERECVALUES !#NoAListWarning!&
	   !*!&CancelList!# MONLIST !*!&RelAutoAdd!# !*!&RelAutoAddProhib!#))

(FLUID '(!*TakeDenseContents !*OBSOLETENAMESINFORM
	 !*!&WeightsList!# !*!&WeightsDPList!# !*!#CheckFailInform))

(SETQ !#NoAListWarning!& " is not a dotted-pair list.")

(SETQ !*!&CancelList!# '(CANCEL cancel Cancel cANCEL))

%  The disposition of the particular mode changers follows the
% manual listing:

%Object type:
%	Ring (default)				SETRINGOBJECT()
%	Module					SETMODULEOBJECT()
%	Two modules (for calculating Tor(*,*))	SETTWOMODULESOBJECT()
%	Factor Algebra ( = Residue class ring)	SETFACTALGOBJECT()
%  Minor variants:
%	Right, Left, 2-sided module?
%	Autoadding of relations?		SETAUTOADDRELATIONSTATE(state)
%		Yes!				AUTOADDRELATIONS()
%		No, absolutely not!		NOAUTOADDRELATIONS()
%		Perhaps, but not right now!	CANCELAUTOADDRELATIONSSETTINGS()
%
%Resolution calculations type:
%	None (default)				SETRESOLUTIONTYPE(NIL)
%	Anick					SETRESOLUTIONTYPE(ANICK)
%
%Polynomial ring set-up:
%	Commutative DEG-REVLEX (default);	COMMIFY(),DEGREVLEXIFY()
%	Commutative DEG-LEX;			  - " -  ,DEGLEXIFY()
%	Non-commutative DEG-LEFTLEX (default);	NONCOMMIFY(),DEGLEFTLEXIFY()
%	Non-commutative ELIM-DEG-LEFTLEX	NONCOMMIFY(),ELIMORDER()
%  Minor variants:
%	Ordinary ( = unit) weights		CLEARWEIGHTS(),SETWEIGHTS()
%	Alternative weights			SETWEIGHTS()
%
%Coefficient arithmetics:
%	Characteristic 0, arbitrary integers (default); SETMODULUS(0)
%	Characteristic 0, only inums;		NOBIGNUMS, - " -
%	Characteristic 2;			SETMODULUS(2)
%	Odd characteristic, ordinary inum arithmetics;  SETMODULUS(pr)
%	Odd characteristic, ordinary bignum arithmetics; - " -
%	Odd characteristic, logarithm table inum arithmetics; - " -,
%						MODLOGARITHMS
%	(Arbitrary Reduce Standard Forms;	SETREDUCESFCOEFFS()
%	 only available in bergman-under-reduce)
%
%Fundamental strategy:
%	Ordinary (Buchberger, Bergman) (with degree first) (default);
%	    with immediate full autoreduction (default);
%						IMMEDIATEFULLREDUCTION
%	    without immediate full autoreduction;    -  "  -
%	Staggered with substance (SAWS).	Various.
%  Minor variants:
%	Densely or sparsely performed factoring out of contents:
%						DENSECONTENTS(),
%						SPARSECONTENTS()
%	Ordinary or Hilbert series limit interruption strategy:
%						ORDNGBESTRATEGY(),
%						MINHILBLIMITSTRATEGY()
%	   (or use SETINTERRUPTSTRATEGY)
%	Calculation start and end points:	SETMINDEG(),
%						GETMINDEG(),
%						SETMAXDEG(),
%						GETMAXDEG().
%
%Input mode minor modification:
%	(No) case sensitivity in algebraic input SETCASESENSALGIN (NIL/T)
%
%Output mode:
%	Lisp form (default):			SETALGOUTMODE(LISP)
%	Ordinary algebraic form:		SETALGOUTMODE(ALG)
%	Macaulay-like algebraic form:		SETALGOUTMODE(MACAULAY)
%
%Minor mode modifications:
%	Collect common factors to exponents (default):
%						EXPTSPRINTMODE()
%	Print each factor separately:		NOEXPTSPRINTMODE()


%   Mode influencing user available switches - a complete list.
%   (However, note that we plan to replace them by mode changers!)

(GLOBAL
 (MAPCAR
  (SETQ !#!&UsrFlags!#!*
	'(CUSTSHOW CUSTSTRATEGY DEGREEPRINTOUTPUT DYNAMICLOGTABLES
	  HOMOGENISED IMMEDIATECRIT IMMEDIATEFULLREDUCTION
	  IMMEDIATERECDEFINE NOBIGNUM
	  OBSOLETENAMESINFORM OLDPRINTMODES1 OLDSERIESMODES1
	  STANDARDANICKMODES
	  PBSERIES  REDUCTIVITY SAVEDEGREE SAVERECVALUES
%	  MONOIDAL POSLEADCOEFFS			% Presently not used?
%	  SAVEACCIDENTALREDUCIBILITYINFO SAVEINHOMOGMONLIST
)) (FUNCTION (LAMBDA (id)  (APPENDLCHARTOID '(!*) id)))))

% (GLOBAL !#!&UsrFlags!#!*)

%	Object type:

%# SETMODULEOBJECT () : - ;
(DE SETMODULEOBJECT ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ !#!&ObjectType 'MODULE)
	(APPLYIFDEF0 '(AnickModuleObject HSerModuleObject)) ))

%# SETTWOMODULESOBJECT () : - ;
(DE SETTWOMODULESOBJECT ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ !#!&ObjectType 'TWOMODULES)
	(APPLYIFDEF0 '(AnickTwoModulesObject HSerTwoModulesObject)) ))

%# SETFACTALGOBJECT () : - ;
(DE SETFACTALGOBJECT ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ !#!&ObjectType 'FACTORALGEBRA)
	(APPLYIFDEF0 '(AnickFactAlgObject HSerFactAlgObject)) ))

%# SETRINGOBJECT () : - ;
(DE SETRINGOBJECT ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ !#!&ObjectType 'RING)
	(APPLYIFDEF0 '(AnickRingObject HSerRingObject)) ))

%# GETOBJECTTYPE () : - ;
(DE GETOBJECTTYPE () (PROGN !#!&ObjectType) )

%# SETOBJECTTYPE (uip) : id ; FEXPR
(DF SETOBJECTTYPE (uip)
 (PROG	(ip)
	(COND ((ATOM uip)
	       (SETQ ip uip))
	      ((AND (EQ (CAR uip) 'QUOTE) (PAIRP (CDR uip))
		    (NULL (CDDR uip)))
	       (SETQ ip (CADR uip)))
	      ((CDR uip)
	       (GO Err))
	      (T
	       (SETQ ip (CAR uip))))
	(COND ((OR (NOT ip) (EQ ip 'RING))
	       (RETURN (SETRINGOBJECT)))
	      ((EQ ip 'MODULE)
	       (RETURN (SETMODULEOBJECT)))
	      ((EQ ip 'TWOMODULES)
	       (RETURN (SETTWOMODULESOBJECT)))
	      ((EQ ip 'FACTORALGEBRA)
	       (RETURN (SETFACTALGOBJECT))))
 Err	(ERROR 99 "Bad object type input") ))

%# MODULEOBJECT () : boolean ;
(DE MODULEOBJECT () (EQ !#!&ObjectType 'MODULE) )


%	Automatic relation adding state:
(DE AUTOADDRELATIONSTATE () (PROGN !*!&RelAutoAdd!#) )

(DE AUTOADDRELATIONS ()
 (PROG	(rt)
	(SETQ rt !*!&RelAutoAdd!#)
	(SETQ !*!&RelAutoAdd!# T)
	(SETQ !*!&RelAutoAddProhib!# NIL)
	(RETURN rt) ))

(DE NOAUTOADDRELATIONS ()
 (PROG	(rt)
	(SETQ rt !*!&RelAutoAdd!#)
	(SETQ !*!&RelAutoAdd!# NIL)
	(SETQ !*!&RelAutoAddProhib!# T)
	(RETURN rt) ))

(DE MAYBEAUTOADDRELATIONS ()
 (COND ((NOT !*!&RelAutoAddProhib!#) (SETQ !*!&RelAutoAdd!# T))) )

(DE CANCELAUTOADDRELATIONSSETTINGS ()
 (PROG	(rt)
	(SETQ rt (CONS !*!&RelAutoAdd!# !*!&RelAutoAddProhib!#))
	(SETQ !*!&RelAutoAdd!# NIL)
	(SETQ !*!&RelAutoAddProhib!# NIL)
	(RETURN rt) ))

(DF SETAUTOADDRELATIONSSTATE (stt)
 (COND ((AND (PAIRP stt) (MEMQ (CDR stt) !*!&CancelList!#))
	(CANCELAUTOADDRELATIONSSETTINGS))
       ((OR (NOT stt) (AND (PAIRP stt) (NOT (CDR stt))))
	(NOAUTOADDRELATIONS))
       (T
	(AUTOADDRELATIONS))) )


%	Resolution calculation types:

%# SETNORESOLUTION () : id ;
(DE SETNORESOLUTION ()
 (PROG	(rt !*USERMODE !*REDEFMSG)
	(SETQ rt (GETRESOLUTIONTYPE))
	(SETQ !*!&ResTyp!# 'NONE)
	(COPYD 'ResolutionInit 'NILNOOPFCN0)
	(COPYD 'ResolutionFixcDegEnd 'NILNOOPFCN0)
	(RETURN rt) ))

%# SETRESOLUTIONTYPE (uip) : id ; FEXPR
(DF SETRESOLUTIONTYPE (clause)
 (PROG	(rt inp)
	(SETQ rt (GETRESOLUTIONTYPE))
	(COND ((ATOM clause)
	       (ERROR 99 "Bad input to SETRESOLUTIONTYPE"))
	      ((OR (MEMQ (SETQ inp (CAR clause)) QuizIds!*)
		   (AND (PAIRP inp)
			(EQ (CAR inp) 'QUOTE)
			(PAIRP (CDR inp))
			(MEMQ (CADR inp) QuizIds!*)))
	       (PRIN2 "** SETRESOLUTIONTYPE should be given one argument:")
	       (TERPRI)
	       (SETQ inp (OneOfAskRead
			  (MAPCAR !*!&ResolutionTypes!# (FUNCTION CAR)))))
	      ((CDR clause)
	       (ERROR 99 "Bad input to SETRESOLUTIONTYPE"))
	      ((NOT (ASSOC inp !*!&ResolutionTypes!#))
	       (SETQ inp (EVAL inp))))
	(COND ((NOT (SETQ inp (ASSOC inp !*!&ResolutionTypes!#)))
	       (ERROR 99 "Bad input to SETRESOLUTIONTYPE")))
	(APPLY (CDR inp) ())
	(RETURN rt) ))

%# GETRESOLUTIONTYPE () : id ;
(DE GETRESOLUTIONTYPE () !*!&ResTyp!#)

%# !*!&ResolutionTypes!# () : id ;
(SETQ !*!&ResolutionTypes!#
 '((NONE . SETNORESOLUTION)
   (NIL . SETNORESOLUTION)
   (ANICK . SETANICKRESOLUTION)))



%	Polynomial ring set-up:

%# COMMIFY () : - ;
(DE COMMIFY ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(OFF NONCOMMUTATIVE)
	(OFF IMMEDIATECRIT)
	(MonCommify)
	(ReclaimCommify)
	(APPLYIFDEF0 '(HSeriesCommify))
	(COPYD 'SPolInputs 'commSPolInputs)
	(COPYD 'SPolPrep 'commSPolPrep)
	(COND ((DEFP 'commPolAlgRead)
	       (COPYD 'PolAlgRead 'commPolAlgRead)))

	% Until the series handling is improved:
	(OFF PBSERIES)
	% Temporary, in order to retain backwards compatibility:
	(COND (!*OLDPRINTMODES1 (EXPTSPRINTMODE)))
	))

%# NONCOMMIFY () : - ;
(DE NONCOMMIFY ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(ON NONCOMMUTATIVE)
	(ON IMMEDIATECRIT)
	(MonNonCommify)
	(ReclaimNonCommify)
	(APPLYIFDEF0 '(HSeriesNonCommify))
	(COPYD 'SPolInputs 'noncommSPolInputs)
	(COPYD 'SPolPrep 'noncommSPolPrep)
	(COND ((DEFP 'noncommPolAlgRead)
	       (COPYD 'PolAlgRead 'noncommPolAlgRead)))
	% Temporary, in order to retain backwards compatibility:
	(COND (!*OLDPRINTMODES1 (NOEXPTSPRINTMODE)))
	(COND (!*OLDSERIESMODES1 (ON PBSERIES)))
	))

(DE ELIMORDER ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ noncommMONORDER 'ELIMLEFTLEX)
	(COPYD 'noncommMONLESSP   'noncommElimLeftLexMONLESSP)
	(COND (!*NONCOMMUTATIVE
                 (COPYD 'MONLESSP 'noncommElimLeftLexMONLESSP)  ))
	))
(DE INVELIMORDER ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ noncommMONORDER 'INVELIMLEFTLEX)
	(COPYD 'noncommMONLESSP   'noncommInvElimLeftLexMONLESSP)
	(COND (!*NONCOMMUTATIVE
                 (COPYD 'MONLESSP 'noncommInvElimLeftLexMONLESSP)  ))
	))

                       
% used together with homohonezation, Otherwise HomogVarInd should be
% pu correctly
(DE HOMOGELIMORDER ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ noncommMONORDER 'HOMOGELIMLEFTLEX)
	(COPYD 'noncommMONLESSP   'noncommHomElimMONLESSP)
	(COND (!*NONCOMMUTATIVE
                 (COPYD 'MONLESSP 'noncommHomElimMONLESSP)                ))
	))
  
(DE DEGLEFTLEXIFY ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(SETQ noncommMONORDER 'TDEGLEFTLEX)
	(COPYD 'noncommMONLESSP 'noncommLexMONLESSP)
	(COND (!*NONCOMMUTATIVE 
              (COPYD 'MONLESSP 'noncommLexMONLESSP)          ))
	))

(COPYD 'NOELIM 'DEGLEFTLEXIFY)

%# DEGLEXIFY () : - ;
(DE DEGLEXIFY ()
 (PROG	(!*USERMODE !*REDEFMSG)
%	(COND (*NONCOMMUTATIVE
%	       (ERROR 1
%		      "DEGLEXIFY not allowed in the non-commutative case.")))
	(SETQ commMONORDER 'TDEGLEX)
	(COPYD 'commMONLESSP 'DegLexMONLESSP)
	(COPYD 'LCorOUT 'DegLexLCorOUT)
	(COPYD 'intermedpmon2PMon 'LISTCOPY)
	(COPYD 'commMONLISPOUT 'LISTCOPY)
%	(COPYD 'MONLISPOUT 'commMONLISPOUT)
%	(COPYD 'commMonAlgOutprep 'commMonAlgOutprep!_copy)
%	(COPYD 'MonAlgOutprep 'commMonAlgOutprep)
	(COPYD 'commPMon2HlbMon 'REVERSE)
	(APPLYIFDEF0 '(HomogDegLexify))
	(COND ((NOT !*NONCOMMUTATIVE) (COMMIFY)))
	))

%# PURELEXIFY () : - ;
(DE PURELEXIFY () % ONLY interesting in conjunction with homogenisation.
 (PROG	(!*USERMODE !*REDEFMSG)
%	(COND (*NONCOMMUTATIVE
%	       (ERROR 1
%		      "PURELEXIFY not allowed in the non-commutative case.")))
	(SETQ commMONORDER 'PURELEX)
	(COPYD 'commMONLESSP 'DegLexMONLESSP)
	(COPYD 'LCorOUT 'DegLexLCorOUT)
	(COPYD 'intermedpmon2PMon 'LISTCOPY)
	(COPYD 'commMONLISPOUT 'LISTCOPY)
%	(COPYD 'MONLISPOUT 'commMONLISPOUT)
%	(COPYD 'commMonAlgOutprep 'commMonAlgOutprep!_copy)
%	(COPYD 'MonAlgOutprep 'commMonAlgOutprep)
	(COPYD 'commPMon2HlbMon 'REVERSE)
	(APPLYIFDEF0 '(HomogPureLexify))
	(COND ((NOT !*NONCOMMUTATIVE) (COMMIFY)))
	))

%# DEGREVLEXIFY () : - ;
(DE DEGREVLEXIFY ()
 (PROG	(!*USERMODE !*REDEFMSG)
%	(COND (*NONCOMMUTATIVE
%	       (ERROR 1
%		      "DEGREVLEXIFY not allowed in the non-commutative case.")))
	(SETQ commMONORDER 'TDEGREVLEX)
	(COPYD 'commMONLESSP 'RevLexMONLESSP)
	(COPYD 'LCorOUT 'RevLexLCorOUT)
	(COPYD 'intermedpmon2PMon 'REVERSE)
	(COPYD 'commMONLISPOUT 'REVERSE)
%	(COPYD 'MONLISPOUT 'commMONLISPOUT)
%	(COPYD 'commMonAlgOutprep 'commMonAlgOutprep!_reverse)
%	(COPYD 'MonAlgOutprep 'commMonAlgOutprep)
	(COPYD 'commPMon2HlbMon 'LISTCOPY)
	(APPLYIFDEF0 '(HomogRevLexify))
	(COND ((NOT !*NONCOMMUTATIVE) (COMMIFY)))
	))


%# REVLEXIFY () : - ; ALIAS FOR DEGREVLEXIFY
(DE REVLEXIFY () (PROGN
  (COND (!*OBSOLETENAMESINFORM (TERPRI)
	 (PRIN2 "*** REVLEXIFY is obsolete - use DEGREVLEXIFY instead. ")
	 (TERPRI)))
  (DEGREVLEXIFY)))



%	Since TDEGREVLEX is default:

(COND ((NOT commMONORDER)
       (SETQ commMONORDER 'TDEGREVLEX)))


%# GETCOMMORDER () : identifier ;
(DE GETCOMMORDER () commMONORDER)

%# SETCOMMORDER (uip) : identifier ; FEXPR
(DF SETCOMMORDER (clause)
 (PROG	(rt inp)
	(SETQ rt (GETCOMMORDER))
	(COND ((ATOM clause)
	       (ERROR 99 "Bad input to SETCOMMORDER"))
	      ((OR (MEMQ (SETQ inp (CAR clause)) QuizIds!*)
		   (AND (PAIRP inp)
			(EQ (CAR inp) 'QUOTE)
			(PAIRP (CDR inp))
			(MEMQ (CADR inp) QuizIds!*)))
	       (PRIN2 "** SETCOMMORDER should be given one argument:")
	       (TERPRI)
	       (SETQ inp (OneOfAskRead
			  (MAPCAR !*!&CommMonOrders!# (FUNCTION CAR)))))
	      ((CDR clause)
	       (ERROR 99 "Bad input to SETCOMMORDER"))
	      ((NOT (ASSOC inp !*!&CommMonOrders!#))
	       (SETQ inp (EVAL inp))))
	(COND ((NOT (SETQ inp (ASSOC inp !*!&CommMonOrders!#)))
	       (ERROR 99 "Bad input to SETCOMMORDER")))
	(APPLY (CDR inp) ())
	(RETURN rt) ))


(SETQ !*!&CommMonOrders!#
 '((TDEGLEX . DEGLEXIFY)
   (PURELEX . PURELEXIFY)
   (TDEGREVLEX . DEGREVLEXIFY)))


%	Since TDEGLEFTLEX is default:

(COND ((NOT noncommMONORDER)
       (SETQ noncommMONORDER 'TDEGLEFTLEX)))

%# GETNONCOMMORDER () : identifier ;
(DE GETNONCOMMORDER () noncommMONORDER)

%# SETNONCOMMORDER (uip) : identifier ; FEXPR
(DF SETNONCOMMORDER (clause)
 (PROG	(rt inp)
	(SETQ rt (GETNONCOMMORDER))
	(COND ((ATOM clause)
	       (ERROR 99 "Bad input to SETNONCOMMORDER"))
	      ((OR (MEMQ (SETQ inp (CAR clause)) QuizIds!*)
		   (AND (PAIRP inp)
			(EQ (CAR inp) 'QUOTE)
			(PAIRP (CDR inp))
			(MEMQ (CADR inp) QuizIds!*)))
	       (PRIN2 "** SETNONCOMMORDER should be given one argument:")
	       (TERPRI)
	       (SETQ inp (OneOfAskRead
			  (MAPCAR *!&NonCommMonOrders!# (FUNCTION CAR)))))
	      ((CDR clause)
	       (ERROR 99 "Bad input to SETNONCOMMORDER"))
	      ((NOT (ASSOC inp *!&NonCommMonOrders!#))
	       (SETQ inp (EVAL inp))))
	(COND ((NOT (SETQ inp (ASSOC inp *!&NonCommMonOrders!#)))
	       (ERROR 99 "Bad input to SETNONCOMMORDER")))
	(APPLY (CDR inp) ())
	(RETURN rt) ))



(SETQ *!&NonCommMonOrders!#
 '((TDEGLEFTLEX . DEGLEFTLEXIFY)
   (ELIMLEFTLEX . ELIMORDER)
   (HOMOGELIMLEFTLEX . HOMOGELIMORDER)
   (INVELIMLEFTLEX . INVELIMORDER)))


%  Minor variants of polynomial ring set-up:


%%%% Various weights handling.

%  Note that !*!&WeightsList!# is internal. Access to it by user
% interface filters through IOWeights2Weights and
% Weights2IOWeights, which (depending on variable orders) might
% reverse the order. Direct access to !*!&WeightsList!# is by
% the macro Weights.

%  On the other hand, at present !*!&WeightsDPList!# is directly
% accessed by GETDPWEIGHTS. There might be reasons to remove this
% from the user interface, replacing it with a macro, too.
% /JoeB 1999-11-26

(DE CLEARWEIGHTS ()
 (PROG	(rt !*USERMODE !*REDEFMSG)
	(SETQ rt (GETWEIGHTS))
	(SETQ !*!&WeightsList!# NIL)
	(SETQ !*!&WeightsDPList!# NIL)
	(CommOrdWeights)
	(NonCommOrdWeights)
	(APPLYIFDEF0 '(HSeriesOrdWeights))
	(RETURN rt) ))

(DF SETWEIGHTS (lint)
 (PROG	(rt aa nr !*USERMODE !*REDEFMSG)
	(COND ((NOT (SETQ aa lint)) (RETURN (CLEARWEIGHTS))))
	(SETQ rt (GETWEIGHTS))
	(COND ((NOT (PAIRP aa))
	       (GO Err))
	      ((AND (PAIRP (CAR aa)) (EQ (LENGTH aa) 1))
	       (SETQ aa (CAR aa))))
	(SETQ nr aa)
  Fl	(COND ((NOT (AND (PAIRP nr)
			 (FIXP (CAR nr))
			 (LESSP 0 (CAR nr))))
	       (GO Err))
	      ((SETQ nr (CDR nr))
	       (GO Fl)))
	(SETQ !*!&WeightsList!# (IOWeights2Weights lint))
	(SETQ nr 2)
	(SETQ aa (CDR !*!&WeightsList!#))
	(SETQ !*!&WeightsDPList!#
	      (TCONC NIL (CONS 1 (CAR !*!&WeightsList!#))))
  Ml	(COND (aa
	       (TCONC !*!&WeightsDPList!# (CONS nr (CAR aa)))
	       (SETQ aa (CDR aa))
	       (SETQ nr (ADD1 nr))
	       (GO Ml)))
	(SETQ !*!&WeightsDPList!# (CAR !*!&WeightsDPList!#))
	(CommAltWeights)
	(NonCommAltWeights)
	(APPLYIFDEF0 '(HSeriesAltWeights))
	(RETURN rt)
  Err	(ERROR 99 lint " bad input to SETWEIGHTS") ))

(DE GETWEIGHTS ()
 (COND (!*!&WeightsList!# (Weights2IOWeights !*!&WeightsList!#))) )

(DE GETWEIGHTDPS () !*!&WeightsDPList!#)

(DE PRINTWEIGHTS ()
 (PROG	(ip)
	(COND ((NULL (SETQ ip (GETWEIGHTS)))
	       (RETURN NIL)))
  Ml	(PRIN2 (CAR ip))
	(COND ((SETQ ip (CDR ip))
	       (PRIN2 '! )
	       (GO Ml)))
	(RETURN T) ))



%Coefficient arithmetics: In coeff.sl, sfcf.sl, ...
%	Characteristic 0, arbitrary integers (default); SETMODULUS(0)
%	Characteristic 0, only inums;		NOBIGNUMS, - " -
%	Characteristic 2;			SETMODULUS(2)
%	Odd characteristic, ordinary inum arithmetics;  SETMODULUS(pr)
%	Odd characteristic, ordinary bignum arithmetics; - " -
%	Odd characteristic, logarithm table inum arithmetics; - " -,
%						MODLOGARITHMS
%	(Arbitrary Reduce Standard Forms;	SETREDUCESFCOEFFS()
%	 only available in bergman-under-reduce)



%Fundamental strategy:
%	Ordinary (Buchberger, Bergman) (with degree first) (default);
%	    with immediate full autoreduction (default);
%						IMMEDIATEFULLREDUCTION
%	    without immediate full autoreduction;    -  "  -
%	Staggered with substance (SAWS).	Various.


%	Minor mode modifications:
%    Mode changers for factoring out contents as densely as possible, or
%    just after finished reductions.

(DE DENSECONTENTS ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(ON TakeDenseContents)
	(Char0DenseContents)
	(APPLYIFDEF0 '(SFCfDenseContents))
 ))

(DE SPARSECONTENTS ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(OFF TakeDenseContents)
	(Char0SparseContents)
	(APPLYIFDEF0 '(SFCfSparseContents))
 ))

%	Ordinary or Hilbert series limit interruption strategy:
%						ORDNGBESTRATEGY(),
%						MINHILBLIMITSTRATEGY()
%	   (or use SETINTERRUPTSTRATEGY)


%	Calculation start and end points:

%  If degno is an integer or NIL, then set MINDEG to this, and
% return the old MINDEG value. Else, signal an error.

%#SETMINDEG (degno:genint) : genint ;
(DE SETMINDEG (degno)
 (PROG	(oldmd)
	(COND ((AND degno (NOT (FIXP degno)))
	       (ERROR 1010 "Bad input to SETMINDEG")))
	(SETQ oldmd MINDEG)
	(SETQ MINDEG oldmd)
	(RETURN oldmd) ))

%#GETMINDEG () : genint ;
(DE GETMINDEG () (PROGN MINDEG))

%  If degno is an integer or NIL, then set MAXDEG to this, and
% return the old MAXDEG value. Else, signal an error.

%#SETMAXDEG (degno:genint) : genint ;
(DE SETMAXDEG (degno)
 (PROG	(oldmd)
	(COND ((AND degno (NOT (FIXP degno)))
	       (ERROR 1010 "Bad input to SETMAXDEG")))
	(SETQ oldmd MAXDEG)
	(SETQ MAXDEG degno)
	(RETURN oldmd) ))

%#GETMAXDEG () : genint ;
(DE GETMAXDEG () (PROGN MAXDEG))



%Input mode minor modification:
%	(No) case sensitivity in algebraic input SETCASESENSALGIN (NIL/T)

(DE SETCASESENSALGIN (boole)
 (COND	(boole (ON !&NoRaiseAlgInp!#))
	(T (OFF !&NoRaiseAlgInp!#))) )

(DE GETCASESENSALGIN () (PROGN !*!&NoRaiseAlgInp!#))



%Output mode:
%	Lisp form (default):			SETALGOUTMODE(LISP)
%	Ordinary algebraic form:		SETALGOUTMODE(ALG)
%	Macaulay-like algebraic form:		SETALGOUTMODE(MACAULAY)
%
%Minor mode modifications:
%	Collect common factors to exponents (default):
%						EXPTSPRINTMODE()
%	Print each factor separately:		NOEXPTSPRINTMODE()

%# EXPTSPRINTMODE () : - ;
(DE EXPTSPRINTMODE ()
    (PROG (!*USERMODE !*REDEFMSG)
	  (CommCollectExpts)
	  (NonCommCollectExpts)
	  (OFF !&!#PrintNoExpts!*)
))

%# NOEXPTSPRINTMODE () : - ;
(DE NOEXPTSPRINTMODE ()
    (PROG (!*USERMODE !*REDEFMSG)
	  (CommPrintNoExpts)
	  (NonCommPrintNoExpts)
	  (ON !&!#PrintNoExpts!*)
))

%% Temporarily, in order to retain backwards compatibility:
% (SETQ !*OLDPRINTMODES1 T)
(SETQ !*OLDSERIESMODES1 T)



%	THE COMPACT MODE HANDLER.

%  A complete or non-complete mode set-up should be representable
% by an object in lisp-form, with legible, relatively long
% identifier names. There could also be a rather short form
% representation, of anick c-version type.
%  Modes could be bound to identifiers as properties; extracted
% therefrom; saved from or restored to the actual active total
% mode set up; printed or read, in short or long form; changed
% partly or totally by means of an interactive mode change.

%  For this to work, we need a couple of fundamental mode
% encoders and decoders.

%  In the long form object, the representation should be a list
% of lists. Each member list should begin with a major mode type
% designator. Typically, the next object would be the name of the
% mode chosen, or NIL if default. There may be optional items,
% e.g. for dependent submodes (as lists organised in a similar
% manner), or for mode information structures such as weight
% lists.

%  In input, any order of mode specifications should be allowed.

%  (Note the input name "uip" = "user input" used to denote that
% this could be input directly from the user, and hence quite
% unreliable.)

(SETQ QuizIds!* '(!? HELP help Help hELP H h))


%# OneOfAskRead (lany) : sexpr ;
(DE OneOfAskRead (lid)
 (PROG	(ip)
	(COND ((NOT (SETQ ip lid))
	       (PRIN2 "(No alternatives exist?)")
	       (TERPRI)
	       (RETURN NIL)))
	(PRIN2 " - One of the following: ")
  Ml	(PRIN2 (COND ((PAIRP ip) (CAR ip))
		     (T ip)))
	(COND ((AND (PAIRP ip) (SETQ ip (CDR ip)))
	       (PRIN2 ", ")
	       (GO Ml)))
	(TERPRI)
	(RETURN (PROMPTREAD "?? > ")) ))


% Old ExtractCurrentModes, for developing purposes only:
(DE OLDECM ()
 (PROG	(rt ri)		% Return value; Return value item
	(SETQ ri
	      (LIST 'VARIABLESETUP
		    (LIST 'RINGTYPE
			  (COND (!*NONCOMMUTATIVE 'NONCOMMUTATIVE)
				(T 'COMMUTATIVE)))
		    (LIST 'COMMUTATIVEORDER (GETCOMMORDER))
		    (LIST 'NONCOMMUTATIVEORDER (GETNONCOMMORDER))
		    (LIST 'VARIABLENUMBER (GETVARNO))
		    (LIST 'INVARIABLES (GETINVARS))
		    (LIST 'OUTVARIABLES (GETOUTVARS))
		    (LIST 'VARIABLEWEIGHTS (GETWEIGHTS))
	      ))
	(SETQ rt (CONS ri rt))
	(SETQ rt (CONS (LIST 'COEFFICIENTDOMAIN
			     Modulus
			     (LIST 'ODDPRIMESMODULI
				   (COND (!*MODLOGARITHMS
					  'MODLOGARITHMIC)
					 (T
					  'ORDINARY))))
		       rt))
	(RETURN rt)
))

% (COPYD 'OLDECM 'ExtractCurrentModes)

%# ExtractCurrentModes () : sexpr ;
(DE ExtractCurrentModes ()
 (PROG	(rt)
	(SETQ rt (MAPCAR !#!&ListOfModes!#!* (FUNCTION ExtractMode)))
  Ml	(COND ((MEMQ NIL rt)
	       (SETQ rt (DELETE NIL rt))
	       (GO Ml)))
	(RETURN rt) ))

%(DE ExtractCurrentModes ()
% (MAPCAR !#!&ListOfModes!#!*
%	 (FUNCTION (LAMBDA (uu) (CONS (CAR uu) (EVAL (CADR uu)))))) )

%# ExtractMode (dottedpair): sexpr ;
(DE ExtractMode (dp)
 (COND ((OR (AND (PAIRP (CADR dp)) (PAIRP (CAADR dp))) (DEFP (CAADR dp)))
	(CONS (CAR dp) (EVAL (CADR dp))))) )


%# GETSETUP () : modestate ;
(DE GETSETUP NIL (COPY (ExtractCurrentModes)))


%# PRINTSETUP
(CL!-AVOIDING (REDUCE!-AVOIDING (PSL!-SPECIFIC
 (DE PRINTSETUP () (PRETTYPRINT (ExtractCurrentModes)) ) )))
(CL!-AVOIDING (PSL!-AVOIDING
 (DE PRINTSETUP () (PRINT (ExtractCurrentModes)) ) ) )
(REDUCE!-SPECIFIC (DE PRINTSETUP () (PRINT (ExtractCurrentModes)) ) )
(CL!-SPECIFIC (DE PRINTSETUP () (PPRINT (ExtractCurrentModes)) ) )


%# ListSwitch (identifier) : sexpr ;
%(DE ListSwitch (id)
% (LIST id (COND ((EVAL (INTERN (COMPRESS (CONS '!* (EXPLODE id))))) 'ON)
%		(T 'OFF))) )

(DE ListSwitch (id)
 (LIST id (COND ((EVAL (APPENDLCHARTOID '(!*) id)) 'ON)
		(T 'OFF))) )

%# SwitchList (lidentifier) : - ;
(DE SwitchList (lid) (EVAL (LIST (CADR lid) (CAR lid))))


%# RestoreMode (modestate) : - ;
(DE RestoreMode (dpany)
 (APPLY (EVAL (CADDR (ASSOC (CAR dpany) !#!&ListOfModes!#!*)))
	(LIST (CDR dpany))) )


(SETQ !#!&ListOfModes!#!*

      '((OBJECTTYPE
	 (LIST (GETOBJECTTYPE)
	       (LIST 'AUTOADDRELATIONSTATE
		     !*!&RelAutoAdd!#
		     !*!&RelAutoAddProhib!#))
	 (FUNCTION RestoreObjectType))
	(RESOLUTIONTYPE
	 (LIST (GETRESOLUTIONTYPE))
	 (FUNCTION RestoreResolutionType))
	(VARIABLESETUP
	 (LIST (LIST 'RINGTYPE
		     (COND (!*NONCOMMUTATIVE 'NONCOMMUTATIVE)
			   (T 'COMMUTATIVE)))
	       (LIST 'COMMUTATIVEORDER (GETCOMMORDER))
	       (LIST 'NONCOMMUTATIVEORDER (GETNONCOMMORDER))
	       (LIST 'VARIABLENUMBER (GETVARNO))
	       (LIST 'INVARIABLES (GETINVARS))
	       (LIST 'OUTVARIABLES (GETOUTVARS))
	       (LIST 'VARIABLEWEIGHTS (GETWEIGHTS)))
	 (FUNCTION RestoreVariableModes))

	(STRATEGY
	 (CONS (LIST 'MINDEG (GETMINDEG))
	       (CONS (LIST 'MAXDEG (GETMAXDEG))
		     (CONS (LIST 'INTERRUPTION (GETINTERRUPTSTRATEGY))
			   (COND (!*HSisLoaded
				  (NCONS (LIST 'HSERIESLIMITATIONS
					       (GETHSERIESMINIMA))))))))
	 (FUNCTION RestoreStrategyModes))

	(COEFFICIENTDOMAIN
	 (LIST Modulus
	       (LIST 'ODDPRIMESMODULI
		     (COND (!*MODLOGARITHMS
			    'MODLOGARITHMIC)
			   (T
			    'ORDINARY))))
	 (FUNCTION RestoreOutputDomain))

	(INPUTFORMAT
	 (LIST (COND ((GETCASESENSALGIN) 'CASESENSALGIN)
		     (T 'NOCASESENSALGIN)))
	 (FUNCTION (LAMBDA (uu)
			   (COND ((MEMQ 'CASESENSALGIN (CDR uu))
				  (SETCASESENSALGIN T))
				 ((MEMQ 'NOCASESENSALGIN (CDR uu))
				  (SETCASESENSALGIN NIL))))))

	(OUTPUTFORMAT
	 (LIST (GETALGOUTMODE)
	       (COND (!*!&!#PrintNoExpts!* 'NOEXPTSPRINT)
		     (T 'EXPTSPRINT)))
	 (FUNCTION (LAMBDA (uu)
			   (PROGN (EVAL (LIST 'SETALGOUTMODE (CAR uu)))
				  (COND ((MEMQ 'EXPTSPRINT (CDR uu))
					 (EXPTSPRINTMODE))
					((MEMQ 'NOEXPTSPRINT (CDR uu))
					 (NOEXPTSPRINTMODE)))))))

	(ANICK
	 (ExtractAnickModes)
	 (FUNCTION RestoreAnickModes))

	(VARIOUSFLAGS
	 (MAPCAR !#!&UsrFlags!#!* 'ListSwitch)
	 (FUNCTION (LAMBDA (uu) (MAPC uu 'SwitchList))))

))

%# RestoreObjectType (sexpr) : - ;
(DE RestoreObjectType (sexpr)
 (PROG	(ip itm)
	(COND ((AND (PAIRP sexpr) (NOT (PAIRP (CAR sexpr))))
	       (EVAL (CONS 'SETOBJECTTYPE sexpr))
	       (SETQ ip (CDR sexpr)))
	      (T
	       (SETQ ip sexpr)))
	(COND ((SETQ itm (ASSOC 'AUTOADDRELATIONSTATE ip))
	       (COND ((CADR itm) (AUTOADDRELATIONS))
		     ((CADDR itm) (NOAUTOADDRELATIONS))
		     (T (CANCELAUTOADDRELATIONSSETTINGS))))) ))


%# RestoreResolutionType (sexpr) : - ;
(DE RestoreResolutionType (sexpr)
 (EVAL (CONS 'SETRESOLUTIONTYPE sexpr)) )

%# RestoreVariableModes (sexpr) : - ;
(DE RestoreVariableModes (sexpr)
 (PROG	(itm)
	(COND ((SETQ itm (ASSOC 'RINGTYPE sexpr))
	       (COND ((EQ (CADR itm) 'COMMUTATIVE) (COMMIFY))
		     (T (NONCOMMIFY)))))
	(COND ((SETQ itm (ASSOC 'COMMUTATIVEORDER sexpr))
	       (EVAL (CONS 'SETCOMMORDER (CDR itm)))))
	(COND ((SETQ itm (ASSOC 'NONCOMMUTATIVEORDER sexpr))
	       (EVAL (CONS 'SETNONCOMMORDER (CDR itm)))))
	(COND ((SETQ itm (ASSOC 'INVARIABLES sexpr))
	       (SETINVARS (CADR itm))))
	(COND ((SETQ itm (ASSOC 'OUTVARIABLES sexpr))
	       (SETOUTVARS (CADR itm))))
	(COND ((AND (SETQ itm (ASSOC 'VARIABLENUMBER sexpr))
		    (CADR itm))
	       (QUESTION THIS)))
	(COND ((SETQ itm (ASSOC 'VARIABLEWEIGHTS sexpr))
	       (EVAL (CONS 'SETWEIGHTS (CADR itm))))) ))

%# RestoreStrategyModes (sexpr) : - ;
(DE RestoreStrategyModes (sexpr)
 (PROG	(itm)
	(COND ((SETQ itm (ASSOC 'INTERRUPTION sexpr))
	       (EVAL (CONS 'SETINTERRUPTSTRATEGY (CDR itm)))))
	(COND ((SETQ itm (ASSOC 'HSERIESLIMITATIONS sexpr))
	       (COND ((NOT !*HSisLoaded)
		      (EVAL (LIST 'LOAD HSERIESFILE!*))
		      (ON HSisLoaded)))
	       (EVAL '(SETHSERIESMINIMUMDEFAULT))
	       (EVAL (CONS 'SETHSERIESMINIMA itm))))
	(COND ((SETQ itm (ASSOC 'MINDEG sexpr))
	       (EVAL (CONS 'SETMINDEG (CDR itm)))))
	(COND ((SETQ itm (ASSOC 'MAXDEG sexpr))
	       (EVAL (CONS 'SETMAXDEG (CDR itm)))))
 ))

%# RestoreOutputDomain (sexpr) : - ;
(DE RestoreOutputDomain (sexpr)
 (PROG	(itm)
	(SETMODULUS (CAR sexpr))
	(COND ((SETQ itm (ASSOC 'ODDPRIMESMODULI sexpr))
	       (COND ((EQ (CADR itm) 'ORDINARY) (OFF MODLOGARITHMS))
		     (T (ON MODLOGARITHMS))))) ))


%# SETSETUP (modestate) : boolean ;
(DE SETSETUP (sexpr)
 (COND	((NOT (CHECKSETUP sexpr))
	 NIL)
	(T
	 (MAPC sexpr (FUNCTION RestoreMode))
	 T)) )

%%%%  Added 1999-07-01, in order to eliminate user switches.  %%%%
%%%%  Should be distributed into their appropriate places!    %%%%

%  The following mode informing switch should NOT be set by users:
% HOMOGENISED.

%  The OLDMODE and OBSOLETE stuff might be merged into one category.
% Anyhow they need not be documented here!


%# GETCUSTSHOW (sexpr) : boolean ;
(DE GETCUSTSHOW () (PROGN !*CUSTSHOW))

%# SETCUSTSHOW (sexpr) : boolean ; FEXPR
(DF SETCUSTSHOW (u)
 (PROG	(rt)
	(SETQ rt (GETCUSTSHOW))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF CUSTSHOW))
	      (T
	       (ON CUSTSHOW)))
	(RETURN rt) ))

%# GETCUSTSTRATEGY (sexpr) : boolean ;
(DE GETCUSTSTRATEGY () (PROGN !*CUSTSTRATEGY))

%# SETCUSTSTRATEGY (sexpr) : boolean ; FEXPR
(DF SETCUSTSTRATEGY (u)
 (PROG	(rt)
	(SETQ rt (GETCUSTSTRATEGY))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF CUSTSTRATEGY))
	      (T
	       (ON CUSTSTRATEGY)))
	(RETURN rt) ))

%# GETDEGREEPRINTOUTPUT (sexpr) : boolean ;
(DE GETDEGREEPRINTOUTPUT () (PROGN !*DEGREEPRINTOUTPUT))

%# SETDEGREEPRINTOUTPUT (sexpr) : boolean ; FEXPR
(DF SETDEGREEPRINTOUTPUT (u)
 (PROG	(rt)
	(SETQ rt (GETDEGREEPRINTOUTPUT))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF DEGREEPRINTOUTPUT))
	      (T
	       (ON DEGREEPRINTOUTPUT)))
	(RETURN rt) ))

%# GETDYNAMICLOGTABLES (sexpr) : boolean ;
(DE GETDYNAMICLOGTABLES () (PROGN !*DYNAMICLOGTABLES))

%# SETDYNAMICLOGTABLES (sexpr) : boolean ; FEXPR
(DF SETDYNAMICLOGTABLES (u)
 (PROG	(rt)
	(SETQ rt (GETDYNAMICLOGTABLES))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF DYNAMICLOGTABLES))
	      (T
	       (ON DYNAMICLOGTABLES)))
	(RETURN rt) ))

%# GETIMMEDIATECRIT (sexpr) : boolean ;
(DE GETIMMEDIATECRIT () (PROGN !*IMMEDIATECRIT))

%# SETIMMEDIATECRIT (sexpr) : boolean ; FEXPR
(DF SETIMMEDIATECRIT (u)
 (PROG	(rt)
	(SETQ rt (GETIMMEDIATECRIT))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF IMMEDIATECRIT))
	      (T
	       (ON IMMEDIATECRIT)))
	(RETURN rt) ))

%# GETIMMEDIATEFULLREDUCTION (sexpr) : boolean ;
(DE GETIMMEDIATEFULLREDUCTION () (PROGN !*IMMEDIATEFULLREDUCTION))

%# SETIMMEDIATEFULLREDUCTION (sexpr) : boolean ; FEXPR
(DF SETIMMEDIATEFULLREDUCTION (u)
 (PROG	(rt)
	(SETQ rt (GETIMMEDIATEFULLREDUCTION))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF IMMEDIATEFULLREDUCTION))
	      (T
	       (ON IMMEDIATEFULLREDUCTION)))
	(RETURN rt) ))

%# GETIMMEDIATERECDEFINE (sexpr) : boolean ;
(DE GETIMMEDIATERECDEFINE () (PROGN !*IMMEDIATERECDEFINE))

%# SETIMMEDIATERECDEFINE (sexpr) : boolean ; FEXPR
(DF SETIMMEDIATERECDEFINE (u)
 (PROG	(rt)
	(SETQ rt (GETIMMEDIATERECDEFINE))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF IMMEDIATERECDEFINE))
	      (T
	       (ON IMMEDIATERECDEFINE)))
	(RETURN rt) ))

%# GETNOBIGNUM (sexpr) : boolean ;
(DE GETNOBIGNUM () (PROGN !*NOBIGNUM))

%# SETNOBIGNUM (sexpr) : boolean ; FEXPR
(DF SETNOBIGNUM (u)
 (PROG	(rt)
	(SETQ rt (GETNOBIGNUM))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF NOBIGNUM))
	      (T
	       (ON NOBIGNUM)))
	(RETURN rt) ))

%# GETPBSERMODE (sexpr) : boolean ;
(DE GETPBSERMODE () (PROGN !*PBSERIES))

%# SETPBSERMODE (sexpr) : boolean ; FEXPR
(DF SETPBSERMODE (u)
 (PROG	(rt)
	(SETQ rt (GETPBSERMODE))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF PBSERIES))
	      (T
	       (ON PBSERIES)))
	(RETURN rt) ))

%# GETREDUCTIVITY (sexpr) : boolean ;
(DE GETREDUCTIVITY () (PROGN !*REDUCTIVITY))

%# SETREDUCTIVITY (sexpr) : boolean ; FEXPR
(DF SETREDUCTIVITY (u)
 (PROG	(rt)
	(SETQ rt (GETREDUCTIVITY))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF REDUCTIVITY))
	      (T
	       (ON REDUCTIVITY)))
	(RETURN rt) ))

%# GETSAVEDEGREE (sexpr) : boolean ;
(DE GETSAVEDEGREE () (PROGN !*SAVEDEGREE))

%# SETSAVEDEGREE (sexpr) : boolean ; FEXPR
(DF SETSAVEDEGREE (u)
 (PROG	(rt)
	(SETQ rt (GETSAVEDEGREE))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF SAVEDEGREE))
	      (T
	       (ON SAVEDEGREE)))
	(RETURN rt) ))

%# GETSAVERECVALUES (sexpr) : boolean ;
(DE GETSAVERECVALUES () (PROGN !*SAVERECVALUES))

%# SETSAVERECVALUES (sexpr) : boolean ; FEXPR
(DF SETSAVERECVALUES (u)
 (PROG	(rt)
	(SETQ rt (GETSAVERECVALUES))
	(COND ((OR (NOT u)
		   (AND (PAIRP u) (OR (NOT (CAR u)) (EQ (CAR u) 'OFF))))
	       (OFF SAVERECVALUES))
	      (T
	       (ON SAVERECVALUES)))
	(RETURN rt) ))


%  CheckWarning issues a warning that the check failed, if the
% fluid variable !*!#CheckFailInform has a non-NIL value. Its
% argument must be a list of evaluable items; the values are printed.
% ("Type EVAL, NOSPREAD" in Standard Lisp Report terminology.)
%  Might it be moved to macros.sl?

%# CheckWarning (lany) : boolean ; MACRO
(DM CheckWarning (u)
 (PROG	(ip rt)
	(COND ((NOT (LISTP u))
	       (TERPRI)
	       (PRIN2 "*** Bad input ")
	       (PRIN2 (CDR u))
	       (PRIN2 " to CheckWarning.")
	       (TERPRI)
	       (PRIN2 "*** The call is replaced by ")
	       (PRIN2 NIL)
	       (PRIN2 ".")
	       (TERPRI)
	       (RETURN NIL)))
	(SETQ ip (REVERSE (CONS 'TERPRI (CDR u))))
	(SETQ rt '((TERPRI) T))
	Ml
	(COND ((EQ (CAR ip) 'TERPRI)
	       (SETQ rt
		     (CONS '(TERPRI)
			   (CONS '(PRIN2 "*** ") rt))))
	      (T
	       (SETQ rt
		     (CONS (LIST 'PRIN2 (CAR ip)) rt))))
	(COND ((SETQ ip (CDR ip))
	       (GO Ml)))
	(RETURN (LIST
		 'COND
		 (CONS '!*!#CheckFailInform rt))) ))


%%%%%	PRELIMINARY, to get things going:	%%%%
%
%(COPYD 'CHECKSETUP 'TNOOPFCN1)


%  PROG variables: Input member list tails for variables, strategy,
% coefficients, input, output, anick, and various flags;
% sub-items of such.

%# CHECKSETUP (any) ; boolean ;
(DE CHECKSETUP (uip)
 (PROG	(vb str cf ip op an vfg itm1 itm2)
	(COND ((NOT (DPLISTP uip))
	       (CheckWarning "The proposed set-up "
			     uip
			     " is not a list of lists.")
	       (RETURN NIL)))
	(COND ((SETQ vb (ATSOC 'OBJECTTYPE uip))
	       (COND ((NOT (LISTP vb))
		      (CheckWarning "The object type item "
				    vb
				    " is not a list.")
		      (RETURN NIL)))))
	(COND ((SETQ vb (ATSOC 'VARIABLESETUP uip))
	       (COND ((NOT (DPLISTP (SETQ vb (CDR vb))))
		      (CheckWarning "The variable setup item "
				    vb
				    !#NoAListWarning!&)
		      (RETURN NIL)))))
	(COND ((SETQ str (ATSOC 'STRATEGY uip))
	       (COND ((NOT (DPLISTP (SETQ str (CDR str))))
		      (CheckWarning "The strategy item "
				    str
				    !#NoAListWarning!&)
		      (RETURN NIL)))))
	(COND ((SETQ cf (ATSOC 'COEFFICIENTDOMAIN uip))
	       (COND ((NOT (AND (PAIRP (SETQ cf (CDR cf)))
				(OR (NOT (CAR cf))
				    (AND (FIXP (CAR cf))
					 (NOT (BM!< (CAR cf) 0))))
				(DPLISTP (CDR cf))))
		      (CheckWarning "Inappropriate coefficient domain item "
				    cf)
		      (RETURN NIL)))))
	(COND ((SETQ ip (ATSOC 'INPUTFORMAT uip))
	       (COND ((NOT (LISTP (SETQ ip (CDR ip))))
		      (CheckWarning "The input format item "
				    ip
				    " is not a list.")
		      (RETURN NIL)))))
	(COND ((SETQ op (ATSOC 'OUTPUTFORMAT uip))
	       (COND ((NOT (LISTP (SETQ op (CDR op))))
		      (CheckWarning "The output format item "
				    op
				    " is not a list.")
		      (RETURN NIL)))))
	(COND ((SETQ an (ATSOC 'ANICK uip))
	       (SETQ an (CDR an))))
	(COND ((SETQ vfg (ATSOC 'VARIOUSFLAGS uip))
	       (COND ((NOT (DPLISTP (SETQ vfg (CDR vfg))))
		      (CheckWarning "The various switches item "
				    op
				    !#NoAListWarning!&)
		      (RETURN NIL)))))
	(COND ((AND (SETQ itm1 (ATSOC 'INTERRUPTION str))
		    (NOT (AND (LISTP itm1)
			      (EQN (LENGTH itm1) 2)
			      (IDP (SETQ itm1 (CADR itm1)))
			      (CHECKINTERRUPTSTRATEGY itm1))))
	       (CheckWarning "The interruption strategy "
			     itm1
			     " is undefined."))
	      ((AND (EQ itm1 'MINHILBLIMITS)
		    (SETQ itm2 (ATSOC 'VARIABLEWEIGHTS vb))
		    (SETQ itm2 (CADR itm2)))
	       (CheckWarning "The minimal Hilbert series limitation strategy"
			     TERPRI
			     "is incompatible with weight setting")))
	(RETURN T) ))


%   I should add a smooth way to handle flags or switches on verbosity,
%    such as !*!#CheckFailInform. Until then, the latter be on:

(SETQ !*!#CheckFailInform T)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%							%%%
%%%	Saving and pushing entire ring structures:	%%%
%%%							%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% The push down list:

(GLOBAL '(!#!&RingStack!#!&))

%  An item on this list be a structure (modes mons . name), where
% modes be the extracted ring setup modes, mons the MONLIST at
% extraction time, and name be an identifyer or other self-evaluating
% lisp object serving as ring name; or NIL for "no name given".

%  At present, I assume the operations to be performed rather rarely.
% Hence, I use the compact mode handler procedures; although these
% make a number of copying et cetera, that we might not want.

%# GetRingModes (void) : any ;
(DE GetRingModes () (ASSOC 'VARIABLESETUP (GETSETUP)))

%  Vsu = Variable set-up (as in the compact mode handler).
%# RestoreRingModes (any) ; boolean ;
(DE RestoreRingModes (Vsu) (SETSETUP (LIST Vsu)))

%# PUSHRING (void) ; int ;
(DE PUSHRING ()
 (PROGN	(SETQ !#!&RingStack!#!&
	      (CONS (LIST (GetRingModes) MONLIST)
		    !#!&RingStack!#!&))
	(SETQ MONLIST (NCONS NIL))
	(LENGTH !#!&RingStack!#!&) ))

%# POPRING (void) ; genint ;
(DE POPRING ()
 (COND (!#!&RingStack!#!&
	(RestoreRingModes (CAAR !#!&RingStack!#!&))
	(SETQ MONLIST (CADAR !#!&RingStack!#!&))
	(ADD1 (LENGTH (SETQ !#!&RingStack!#!& (CDR !#!&RingStack!#!&))))) ))

%  Prog variable: Old Ring.
%# SWITCHRING (void) ; boolean ;
(DE SWITCHRING ()
 (PROG	(or)
	(COND ((NOT !#!&RingStack!#!&)
	       (RETURN NIL)))
	(SETQ or (LIST (GetRingModes) MONLIST))
	(POPRING)
	(SETQ !#!&RingStack!#!& (CONS or !#!&RingStack!#!&))
	(RETURN T) ))

(ON RAISE)
