%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (C) 1995,1996 Joergen Backelin, Svetlana Cojocaru,
%% Victor Ufnarovski
%%
%% Bergman is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY.  No author or distributor
%% accepts responsibility to anyone for the consequences of using it
%% or for whether it serves any particular purpose or works at all,
%% unless (s)he says so in writing.  Refer to the Bergman General
%% Public License for full details.

%% Everyone is granted permission to copy, modify and redistribute
%% bergman, but only under the conditions described in the
%% Bergman General Public License.   A copy of this license is
%% supposed to have been given to you along with bergman so you
%% can know your rights and responsibilities.  It should be in a
%% file named copyright.  Among other things, the copyright notice
%% and this notice must be preserved on all copies.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(OFF RAISE)

%	CHANGES:

%  Corrected FACTALGADDITIONALRELATIONS./JoeB 2002-10-12

%  2002-07-11, VU and SC added FACTALGADDITIONALRELATIONS and
% HOCHADDITIONALRELATIONS, and numerous auxiliaries for these.

%  Removed ! within quotes./JoeB 1999-07-02


% Imports: PrintSeries, DoublePrint, DoubleNewLine, NLength, serMaxLength,
%	   powChangeSign; MaxL.
% Exports: ScreenInput, CheckInput, CheckOutputGB, CheckOutputHs,
%	   DoublePrint, DoubleNewLine, PrintSeries, PrintForAnick,
%	   revnoncommPolAlgRead, BinomsForNCHomogenisation,
%	   FACTALGADDITIONALRELATIONS, HOCHADDITIONALRELATIONS.
% Available: 

(GLOBAL '(NMODGEN SERMAXDEG OutModFile GbOutFile ScInput InModFile InRingFile
	 HomogVarIndex HsOutFile MaxL ))





(DE ScreenInput ()
          (SETQ ScInput T)
          (PRIN2 "Input the Maximum Degree you want to calculate")(TERPRI)
          (SETQ MAXDEG (READ))
          (PRIN2 "Input the quantity of the module generators")(TERPRI)
          (SETQ NMODGEN (READ))
          (PRIN2 "Now input ALL ring and module variables but ONLY") (TERPRI)
          (PRIN2 "the ring ideal generators in algebraic form, thus:")
          (TERPRI) (PRIN2 "      vars v1, ..., vn;") (TERPRI)
          (PRIN2 "       r1, ..., rm;") (TERPRI)
          (PRIN2 "where v1, ..., vn are all the variables, and r1, ..., rm the generators.")
          (TERPRI)
          (ALGFORMINPUT)
)





(DE CheckInput (files)
  (COND ( (NOT (AND (FILEP (CAR files)) (FILEP (CADR files))))
          (PRIN2 "***Input files must exist")  (TERPRI)
          (PRIN2 "Input data from the keyboard")  (TERPRI)
          (ScreenInput)
        )
        (T
           (SETQ InRingFile (CAR files))
           (SETQ InModFile  (CADR files))
           (SETQ ScInput NIL)
           (DSKIN InRingFile)
        )
  )
)

(DE CheckOutputGB (files )
   (COND ( (NOT (STRINGP (CADDR files)) )
           (PRIN2 "***Incorrect output file.") (TERPRI)
           (PRIN2 "Do you agree to use the file outf____.mgb as output ?" )
           (TERPRI)
           (COND ( (YESP "Type Yes or No")
                   (SETQ GbOutFile "outf____.mgb")
                   (PRIN2 "outf____.mgb is used as output file") (TERPRI)
                   (PRIN2 "Don't forget to rename it after calculations. " )
                   (TERPRI)
                )
                (T
                   (PRIN2 "No output file. Program is canceled") (TERPRI)
                   (QUIT) %It should be changed after the implementation
                          %of new input-output files handling procedure
                )
           )
         )
         (T (SETQ GbOutFile (CADDR files)))
   )
)

(DE CheckOutputHs (files)
    (COND ( (NOT (STRINGP (CADDDR files)))
            (PRIN2 "***Incorrect output file.") (TERPRI)
            (PRIN2 "Do you agree to use the file outf____.mhs as output ?" )
            (TERPRI)
            (COND ((YESP "Type Yes or No")
                   (SETQ HsOutFile "outf____.mhs")
                  )
                  (T
                   (PRIN2 "No output file. Program is canceled") (TERPRI)
                   (QUIT) %It should be changed after the implementation
                          %of new input-output files handling procedure

                  )
             )
          )
          (T (SETQ HsOutFile (CADDDR files)))
    )
)
%The same as CHANNELPRIN2
(DE ChannelWrite (outchan outitem)
   (PROG (oldchannel)
       (SETQ oldchannel (WRS outchan))
       (PRIN2 outitem)
       (WRS oldchannel)
   )
)

%The same as CHANNELTERPRI
(DE ChannelNewLine (outchan)
   (PROG (oldchannel)
       (SETQ oldchannel (WRS outchan))
       (TERPRI)
       (WRS oldchannel)
   )
)

(DE DoublePrint (What)
   (PROGN
    (PRIN2 What)
    (COND (OutModFile (ChannelWrite  OutModFile What))
    )
   )
)

(DE DoubleNewLine ()
  (PROGN
   (TERPRI)
   (COND (OutModFile (ChannelNewLine OutModFile))
   )
  )
)

(DE PrintPara (para)
        (PROGN
           (COND ( (NEQ (CDR para) 0)
                   (PROGN
                      (OutSpaces (DIFFERENCE MaxL (NLength (CDR para))))
                      (COND
                       ((MINUSP (CDR para)) (DoublePrint " "))
                       ( T                  (DoublePrint "+"))
                      )
                      (DoublePrint  (CDR para))
                      (COND
                         ( (NEQ (CAR para) 0)
                              (PROGN
                                 (DoublePrint  "*t^")
                                 (DoublePrint  (CAR para))
                              )
                         )
                       )
                       (DoubleNewLine)
                   )
                 )
                  (T NIL)
           )
        )
)


(DE PrintSeries (ser)
          (PROGN
            (DoubleNewLine)
            (serMaxLength ser)
            (MAPC ser 'PrintPara)
          )
)

(DE OutSpaces (N )
    (COND ((LESSP N 1) NIL)
          (T (PROGN
              (DoublePrint " ")
              (OutSpaces (SUB1 N))
             )
    )     )
)

(DE Prettyprintoutvars (outchan varslist)
 (PROG (ov oldch)
       (COND ((NOT (SETQ ov varslist))
              (RETURN NIL)
             )
       )
       (SETQ oldch (WRS outchan))
       (PRIN2 (CAR ov))
   M1  (COND ((SETQ ov (CDR ov))
              (PRIN2 ",")
              (PRIN2 (CAR ov))
              (GO M1)
            )
       )
       (WRS oldch)
       (RETURN T)
 )
)
(DE PrintForAnick ()
  (PROG (modbegin)
    (ChannelWrite  GBasOutChan  "% setinvars ")
    (Prettyprintoutvars GBasOutChan  (GETOUTVARS))
    (ChannelWrite  GBasOutChan  ";")
    (ChannelNewLine  GBasOutChan)

    (ChannelWrite  GBasOutChan  "% setmodulevars ")
    (SETQ modbegin (DIFFERENCE (LENGTH (GETOUTVARS)) (DIFFERENCE NMODGEN 1)))

    (Prettyprintoutvars GBasOutChan  (PNTH (GETOUTVARS) modbegin))
    (ChannelWrite  GBasOutChan  ";")
    (ChannelNewLine GBasOutChan)


    (ChannelWrite  GBasOutChan  "% (SETQ MAXDEG ")
    (ChannelWrite  GBasOutChan  MAXDEG)
    (ChannelWrite  GBasOutChan  " )")
    (ChannelNewLine GBasOutChan)
  )
)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Procedures for reverting  input polynomoals                %
%  Added by SC & VU 02-06-09                                 %
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
%(DE RevCopyMon (mon)
%   (CONS (CAR mon) (MONINTERN (REVERSE (DELETE 0 (CDDR mon))))))

% More modularised version /JoeB 02-06-27
(DE RevCopyMon (cfmon)
   (Cf!&Mon2Tm (Cf cfmon) (MONINTERN (REVERSE (MONLISPOUT (Tm2PMon cfmon))))))
 

(DE RevCopyPol (pol)
 (PROG (newpol p)
  (SETQ newpol (NCONS NIL))
  (SETQ p (CDR pol))
NextMonom 
 (COND ((NULL p) 
         (RETURN newpol))
 )
 (TermInsert (RevCopyMon (CAR p)) newpol)
 (SETQ p (CDR p))
 (GO NextMonom)
 ))


%(DE ShiftCopyMon (mon n) (CONS (CAR mon) (MONINTERN (ADDINTTOLIST (DELETE 0 (CDDR mon)
%) n))))

(DE ShiftCopyMon (cfmon n) (Cf!&Mon2Tm (Cf cfmon) (MONINTERN (ADDINTTOLIST (MONLISPOUT (Tm2PMon cfmon)
) n))))

(DE SHIFTCopyPol (pol n)
 (PROG (newpol p)
  (SETQ newpol (NCONS NIL))
  (SETQ p (CDR pol))
NextMonom 
 (COND ((NULL p) 
         (RETURN newpol))
 )       
 (TermInsert (ShiftCopyMon (CAR p)n ) newpol)
 (SETQ p (CDR p))
 (GO NextMonom)
 ))  

(DE SHIFTCopyListPol (ll n)
  (PROG (res)
  (COND ((NULL ll)(SETQ res NIL))
        (T (SETQ res (CONS (SHIFTCopyPol (CAR ll) n) (SHIFTCopyListPol (CDR ll) n)))))
  (RETURN res)))

%(DE RevCopyListPol (listpol)
% (PROG (newlist p)
% (SETQ newlist (NCONS NIL))
% (SETQ p  listpol)
%NextPol
% (COND ((NULL p) (RETURN newlist)))
% (SETQ newlist (CONS (RevCopyPol (CAR  p)) newlist))
% (PRIN2 "Here in NextPol l= ")(PRIN2 (LENGTH newlist))
% (SETQ p (CDR p))
% (GO NextPol)
%))

%(DE RevShiftCopyListPol (listpol n) 
%  (PROG (ll)
%  (SETQ ll (MAPCAR listpol 'RevCopyPol))
%  (RETURN (SHIFTCopyListPol ll n))
%))

(DE RevShiftCopyListPol (listpol n) 
 (SHIFTCopyListPol (MAPCAR listpol 'RevCopyPol) n)
)

(DE revnoncommPolAlgRead (JustRead)
  (RevCopyPol (noncommPolAlgRead JustRead)))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% End of Procedures for reverting  input polynomoals    %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%(DE ShortMonom ( c i j)
% (CONS c (MONINTERN (LIST i j))))

(DE ShortMonom ( c i j)
 (Cf!&Mon2Tm c (MONINTERN (LIST i j))))

(DE Binom (i1 j1 i2 j2)
 (PROG (pol)
 (SETQ pol (mkAPol)) %(NCONS NIL)
 (TermInsert (ShortMonom 1 i1 j1) pol)
 (TermInsert (ShortMonom -1 i2 j2) pol)
 (RETURN pol))
)

(DE BinomsForFactorAlgebra ()
 (PROG (BinomList i j n)
  (SETQ BinomList (NCONS NIL))
  (SETQ i 1)
  (SETQ n (ADD1 (CAR (DIVIDE (LENGTH (GETINVARS) ) 2))))
  (SETQ j (ADD1 n))
 Loop
    (SETQ BinomList (CONS (Binom j n n i) BinomList))
    (SETQ i (ADD1 i))
    (SETQ j (ADD1 j))
    (COND ((LESSP i n) 
           (GO Loop)))
    (RETURN BinomList)
))

(DE BinomsForNCHomogenisation ()
 (PROG (BinomList i j n)
  (SETQ BinomList (NCONS NIL))
  (SETQ i 1)
  (SETQ n HomogVarIndex)
 Loop
    (SETQ BinomList (CONS (Binom i n n i) BinomList))
    (SETQ i (ADD1 i))   
    (COND ((LESSP i n) 
           (GO Loop)))
    (RETURN BinomList)
))

(DE BinomsForHochshild ()
 (PROG (BinomList i j n nn nn1 nn2)
  (SETQ BinomList (NCONS NIL))
  (SETQ n (SUB1 (CAR (DIVIDE (LENGTH (GETINVARS) ) 2))))
  (SETQ nn (PLUS2 n n))
  (SETQ nn1 (ADD1 nn))
  (SETQ nn2 (ADD1 nn1))
  (SETQ j  n)
 Loop1
    (SETQ j (ADD1 j))
    (COND ((LESSP nn j)  (RETURN BinomList)))
    (SETQ BinomList (CONS (Binom nn1 j nn1 (DIFFERENCE j n)) BinomList))
    (SETQ BinomList (CONS (Binom  j  nn2 (DIFFERENCE j n) nn2) BinomList))
    (SETQ i 0)
    Loop2
      (SETQ i (ADD1 i))
      (SETQ BinomList (CONS (Binom i j j i) BinomList))
            (COND ((LESSP i n) 
         (GO Loop2)))
    (GO Loop1)
))

%(DE NOADDITIONALRELATIONS (ll)
%   (RETURN ll))

%(COPYD 'ADDADDITIONALRELATIONS 'NOADDITIONALRELATIONS)



(DE FACTALGADDITIONALRELATIONS (ll)
  (APPEND ll (BinomsForFactorAlgebra)) )

(DE HOCHADDITIONALRELATIONS (ll )
  (PROG (n)
  (SETQ n (SUB1 (CAR (DIVIDE (LENGTH (GETINVARS) ) 2))))
  (SETQ ll(APPEND ll (RevShiftCopyListPol ll n)))
  (RETURN (APPEND ll (BinomsForHochshild)))))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% End of Procedures for input of additional polynomials %%%% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




(ON RAISE)



