%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Copyright (C) 1992,1994,1996,1997 Joergen Backelin
%%
%% Bergman is distributed in the hope that it will be useful,
%% but WITHOUT ANY WARRANTY.  No author or distributor
%% accepts responsibility to anyone for the consequences of using it
%% or for whether it serves any particular purpose or works at all,
%% unless (s)he says so in writing.  Refer to the Bergman General
%% Public License for full details.

%% Everyone is granted permission to copy, modify and redistribute
%% bergman, but only under the conditions described in the
%% Bergman General Public License.   A copy of this license is
%% supposed to have been given to you along with bergman so you
%% can know your rights and responsibilities.  It should be in a
%% file named copyright.  Among other things, the copyright notice
%% and this notice must be preserved on all copies.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Renamed strategy.sl (from groebcompalg.sl) 1994-09-00.

%	CHANGES:

%  (Old) SKIPCDEG --> IGNORECDEG; but added (new) SKIPCDEG, and
% CLEARCDEGREEOBSTRUCTIONS.  Fixed hsminFixNcDeg to work in
% non-commutative mode, too./JoeB 2002-07-11

%  Introduced CHECKINTERRUPTSTRATEGY./JoeB 1999-12-06.

%  GETD --> DEFP./JoeB 1999-07-02

%  Changed PutRecDef1 to PutRecDef./JoeB 1998-04-07.

%  Moved strategic auxiliary deglist operating procedures here
% (from staggering stuff): PutLeadMonPtr, PutLeadMonPtrsinPolList,
% PutLeadMonPtrsinPolDegList, LeadMonList2PolList,
% LeadMonDegList2PolDegList, PolList2LeadMonList,
% PolDegList2LeadMonDegList, LeadMonList2LeadMonDegList,
% PolList2PolDegList./JoeB 1997-08-21

%  Added type information./JoeB 1996-08-09.

%  Added New Groebner basis element strategy modifications. As a
% consequence, parts of old 'main' stuff was moved here./JoeB 1996-06-23


(OFF RAISE)


% Import: MONFACTORP, MonFactorP1, TOTALDEGREE, CALCPOLRINGHSERIES,
%	  GETVARNO, CALCRATHILBERTSERIES, FixEndDegreeThings,
%	  PutRecDef, REMLASTSERIESCALC; GBasis, cGBasis, InPols,
%	  cInPols, SPairs, cSPairs, SP2r, !*NONCOMMUTATIVE,
%	  !*IMMEDIATECRIT, !*IMMEDIATERECDEFINE, !*CUSTSHOW, IGNORECDEG.
% Export: PutLeadMonPtr, PutLeadMonPtrsinPolList,
%	  PutLeadMonPtrsinPolDegList, LeadMonList2PolList,
%	  LeadMonDegList2PolDegList, PolList2LeadMonList,
%	  PolDegList2LeadMonDegList, LeadMonList2LeadMonDegList,
%	  PolList2PolDegList, (comm-, noncomm-)SPolInputs, FixNcDeg,
%	  nGbeStratInit, FixNGbe, StratFixcDegEnd,
%	  CHECKINTERRUPTSTRATEGY.
% Available: PAIRELTLIST, FINDCOMPS, CLEARCDEGREEGKINPUT,
%	  CLEARCDEGREEOBSTRUCTIONS, ORDNGBESTRATEGY,
%	  MINHILBNGBESTRATEGY, SETINTERRUPTSTRATEGY, GETINTERRUPTSTRATEGY.
% Potentially user defined:  HSERIESMINCRITDISPLAY.

(GLOBAL '(Edges Off Queue Waiting GBasis !*IMMEDIATECRIT
	  !*IMMEDIATERECDEFINE cDeg InPols cInPols SPairs cSPairs
	  NewGbeStrategies!* cNGbeStrat!* MaxNewcGbes!&!* IGNORECDEG
	  INPUTONLY))

(FLUID '(SP2r))

(SETQ Edges (NCONS NIL))
(SETQ Off (NCONS NIL))
(SETQ Queue (NCONS NIL))
(SETQ Waiting (NCONS NIL))


%	DEGLIST HANDLING AUXILIARIES.

%  Various strategy implementations may work with deglists (lists of
% lists whose first member is a degree). The following procedures
% operate on or convert from/to/between such structures.

%# PutLeadMonPtr (augpol) : - ;
(DE PutLeadMonPtr
 (augpol) (PutMpt (APol2Lm augpol) augpol))


%# PutLeadMonPtrsinPolList (laugpol) : - ;
(DE PutLeadMonPtrsinPolList (laugpol) (MAPC laugpol (FUNCTION PutLeadMonPtr)))


%# PutLeadMonPtrsinPolDegList (dlaugpol) : - ;
(DE PutLeadMonPtrsinPolDegList (dlaugpol)
 (PROG	(AA)
	(SETQ AA dlaugpol)
  Ml	(COND (AA
	       (PutLeadMonPtrsinPolList (CDAR AA))
	       (SETQ AA (CDR AA))
	       (GO Ml))) ))


%# LeadMonList2PolList (laugmon) : laugpol ;
(DE LeadMonList2PolList (lmon)
 (MAPCAR lmon (FUNCTION (LAMBDA (mon) (Mpt mon)))) )


%# LeadMonDegList2PolDegList (dlaugmon) : (dlaugpol) ;
(DE LeadMonDegList2PolDegList (dlmon)
 (MAPCAR dlmon
	 (FUNCTION (LAMBDA (auglmon)
			   (CONS (CAR auglmon)
				 (LeadMonList2PolList (CDR auglmon)))))) )


%# PolList2LeadMonList (laugpol) : laugmon ;
(DE PolList2LeadMonList (laugpol)
 (MAPCAR laugpol (FUNCTION (LAMBDA (augpol) (APol2Lm augpol)))) )


%# PolDegList2LeadMonDegList (dlaugpol) : dlaugmon ;
(DE PolDegList2LeadMonDegList (dlaugpol)
 (MAPCAR dlaugpol
	 (FUNCTION (LAMBDA (auglaugpol)
			   (CONS (CAR auglaugpol)
				 (PolList2LeadMonList (CDR auglaugpol)))))) )


%# LeadMonList2LeadMonDegList (laugmon) : dlaugmon ;
(DE LeadMonList2LeadMonDegList (lmon)
 (PROG	(AA BB CC DD RT)
	(SETQ RT (SETQ AA (NCONS (LIST (TOTALDEGREE (PMon (CAR lmon)))
				       (CAR lmon)))))
	(SETQ BB (CDAR AA))
	(SETQ CC (CDR lmon))
  Ml	(COND ((NOT CC)
	       (RETURN RT))
	      ((EQ (SETQ DD (TOTALDEGREE (PMon (CAR CC)))) (CAAR AA))
	       (RPLACD BB (NCONS (CAR CC)))
	       (SETQ BB (CDR BB)))
	      ((LESSP (CAAR AA) DD)
	       (RPLACD AA (NCONS (LIST DD (CAR CC))))
	       (SETQ BB (CDAR (SETQ AA (CDR AA)))))
	      (T
	       (ERROR 99
		"Not non-decreasing input to LeadMonList2LeadMonDegList")))
	(SETQ CC (CDR CC))
	(GO Ml) ))


%# PolList2PolDegList (laugpol) : dlaugpol ;
(DE PolList2PolDegList (laugpol)
 (PROG	(AA BB CC DD RT)
	(SETQ RT (SETQ AA (NCONS (LIST (TOTALDEGREE (PMon (CAR laugpol)))
				       (CAR laugpol)))))
	(SETQ BB (CDAR AA))
	(SETQ CC (CDR laugpol))
  Ml	(COND ((NOT CC)
	       (RETURN RT))
	      ((EQ (SETQ DD (TOTALDEGREE (APol2Lpmon (CAR CC)))) (CAAR AA))
	       (RPLACD BB (NCONS (CAR CC)))
	       (SETQ BB (CDR BB)))
	      ((LESSP (CAAR AA) DD)
	       (RPLACD AA (NCONS (LIST DD (CAR CC))))
	       (SETQ BB (CDAR (SETQ AA (CDR AA)))))
	      (T
	       (ERROR 99
		      "Not non-decreasing input to PolList2PolDegList")))
	(SETQ CC (CDR CC))
	(GO Ml) ))


% The non-commutative version of the ordinary strategy.

%	 NOTE 91-11-06: The TOTALDEGREE below is taken on CDR(PMon(mon))
%	etcetera, which is rather bad.

%# noncommSPolInputs (augmon) : critpairs ;
(DE noncommSPolInputs (mon)
 (PROG	(AA BB)
	(SETQ BB (Mpt mon))
	% Changed 91-05-13 and 91-08-11:
	(COND ((OR !*IMMEDIATECRIT
		   (EQ (CDR BB) 1)
		   (EQ (TOTALDEGREE (CDAAR BB))
		       (TOTALDEGREE (CDR (PMon mon))))
		   (NOT (SETQ AA (ListMonFactorP (CDR GBasis) (PMon mon)))))
	       (PutMpt mon
		       (Mpt (MinMon (LIST (CAAR BB) (CDAR BB)))))
	       (COND (!*IMMEDIATERECDEFINE (PutRecDef mon (CAAR BB))))
	       (RETURN BB)))
%	       (GO Mlend)
	(PutMpt mon (Mpt (MinMon (LIST (CAAR BB) (CDAR BB) (CAR AA)))))
	(RETURN NIL) ))


% HERE THE COMPONENT ALGORITHM IS IMPLEMENTED. It should do a) a
% list AA of all leading monomials dividing the given monomial; b) a list
% BB of the components of the complement graph on AA to the POINTER set
% of edges; c) a choice of one polynomial from each component, and d) a
% list of pairs of (length BB) - 1 differences between the chosen elements.
% This list is returned, in order to let another routine make the
% S-polynomials out of it. After the procedure is ready, the POINTER is
% changed to a pointer to a reduction of the LCM.
%  There are several short-cuts available within the algorithm:
% A) One may check whether all AA elements actually appear in the AA or not.
%   If there is any one NOT appearing, then the complement graph is a cone,
%   and thus connected. (One possibility: FIRST form a preliminary AA out of
%   POINTER; THEN go through all leading monomials, checking that those
%   dividing the monomial are on AA. If one is not, abort.)
% B) If AA has just two elements, then (since POINTER is not empty)
%   the complementary graph is discrete, and POINTER contains precisely
%   one pair, whose S-polynomial should be calculated. (Output := POINTER.)

%  There is also a number of interesting choices: Which of the available
% polynomials are probably the better ones from which to construct the
% S-polynomials? Here are 5 suggestions:
%	1) Use arbitrary order;
%	2) Prefer lower total-degree;
%	3) Prefer higher total-degree;
%	4) Prefer lower number of appearing monomials;
%	5) Prefer "relatively lower" second monomial (i.e., revlex lower
%	  second monomial after multiplying up to the S-pol). No second
%	  monomial of course is lowest of all.
%  Right now, MinMon uses 4). (This PRIORITY is set in 'main', by
% FixGBasElts, however, by means of CALCREDUCTORPRIORITY, which the
% customer might wish to change.)

%# CALCREDUCTORPRIORITY (augmon) : polpriority ;
(DE CALCREDUCTORPRIORITY (augmon)
 (LENGTH (PPol (Mpt augmon))))


% The main function (exported). It returns a list of pairs of Groebner basis
% elements (Gbe's) (represented by their LeadMons as usual), which are to have
% their S-Polynomials reduced.
%  As a side effect, the monomial "mon" is to have its POINTER pointing
% to an 'optimal' Gbe reducing it.

%# commSPolInputs (augmon) : critpairs ;
(DE commSPolInputs (mon)
 (PROG	(AA BB CC)

%	List the Gbe's appearing in the proposed pairs:
	(SETQ AA (PAIRELTLIST (Mpt mon)))

%	Is there another Gbe reducing mon? (Then no SPols need be reduced.)
	(COND ((SETQ BB (ConeP (PMon mon) AA))
	       (PutMpt mon (Mpt (MinMon (CONS (CAR BB) AA)))) (RETURN NIL))

	      %	Else, is there but one pair?
	      ((NOT (CDR (SETQ BB (Mpt mon))))
	       (PutMpt mon (Mpt (MinMon AA)))
	       (RETURN BB))

	      %	Else, is there but one component?
	      ((NOT (CDR (SETQ BB (FINDCOMPS AA BB))))
	       (PutMpt mon (Mpt (MinMon (CAR BB)))) (RETURN NIL)))

%	Else, some reductions must be made.
%	Choose the minimal Gbe in each component, and the minimum AA of
%	them all; let POINTER point to that Gbe.
	(SETQ BB (MAPCAR BB 'MinMon))
	(PutMpt mon (Mpt (SETQ AA (MinMon BB))))

%	Delete AA from BB, and make BB a list of the pairs (AA . BB-element),
%	with minimal garbage created:
	(COND ((Mon!= AA (CAR BB))
	       (SETQ BB (CDR BB))
	       (SETQ CC BB)
	       (GO Sl)))
	(SETQ CC BB)
  Ml	(RPLACA CC (CONS AA (CAR CC)))
	(COND ((AND (CDR CC) (Mon!= AA (CADR CC)))
	       (RPLACD CC (CDDR CC))
	       (GO Sl2)))
	(COND ((SETQ CC (CDR CC))
	       (GO Ml)))
  Sl	(RPLACA CC (CONS AA (CAR CC)))
  Sl2	(COND ((SETQ CC (CDR CC))
	       (GO Sl)))
	(RETURN BB) ))

%# SPolInputs (augmon) : critpairs ;
(COPYD 'SPolInputs 'commSPolInputs)

%# PAIRELTLIST (ldpany) : lany ;
(DE PAIRELTLIST (pairlist)
 (PROG	(AA BB)
	(SETQ AA pairlist)
	Ml
	(COND ((NOT (MEMQ (CAAR AA) BB))
	       (SETQ BB (CONS (CAAR AA) BB))))
	(COND ((NOT (MEMQ (CDAR AA) BB))
	       (SETQ BB (CONS (CDAR AA) BB))))
	(COND ((SETQ AA (CDR AA))
	       (GO Ml)))
	(RETURN BB) ))

% FINDCOMPS is a quite general function, taking {vertices} and {edges} of
% a simple graph as its input, and yielding a list of the connected components
% of the complementary graph as its output. HOWEVER, there must be at least 2
% vertices and 1 edge.
% It uses a BFS algorithm.
% Meaning of PROG variables: Components found (so far); Queue-place;
% Edges-position; Off-position; Waiting-position; Currently found vertex (with
% an edge to the component). Here the Queue contains the vertices already
% found in the current component; Off the other vertices found to have an edge
% (and thus NOT a "complementary edge") to the current vertex ( = Cadr(CC) );
% Waiting the rest of the vertices; and Edges contains the yet not used-up
% edges.

% EQ tests are used for vertex-equality. Applying this to monomial vertices
% only works if Mon!= = EQ; else make a copy of FINDCOMPS for this purpose.

% WARNING: The input is destroyed in the process.

%# FINDCOMPS (lany, ldpany) : ldpany ;
(DE FINDCOMPS (lverts ledges)
 (PROG	(AA CQ CE CO CW CV)
	(RPLACD Edges ledges)
	(RPLACD Waiting (CDR  lverts))
	(RPLACD Queue lverts)
  Ml	(RPLACD (SETQ CQ (CDR Queue)) NIL)
  Sl	(COND ((NOT (CDR (SETQ CE Edges)))
	       (RETURN (CONS (CDR (NCONC Queue (CDR Waiting))) AA))))
	(RPLACD Off NIL)
	(SETQ CO Off)
  SSl	(COND ((EQ (CAR CQ) (CAADR CE))
	       (SETQ CV (CDADR CE)))
	      ((EQ (CAR CQ) (CDADR CE))
	       (SETQ CV (CAADR CE)))
	      ((CDR (SETQ CE (CDR CE)))
	       (GO SSl))
	      (T
	       (GO GSl)))
	(RPLACD CE (CDDR CE))
	(SETQ CW Waiting)
  SSSl	(COND ((CDR CW)
	       (COND ((EQ (CADR CW) CV)
		      (RPLACD CO (CDR CW))
		      (RPLACD CW (CDDR CW))
		      (RPLACD (SETQ CO (CDR CO)) NIL))
		     (T
		      (SETQ CW (CDR CW)) (GO SSSl)))))
	(COND ((CDR CE)
	       (GO SSl)))
  GSl	(COND ((CDR Waiting)
	       (NCONC CQ (CDR Waiting))))
	(COND ((NOT (CDR (RPLACD Waiting (CDR Off))))
	       (RETURN (CONS (CDR Queue) AA)))
	      ((SETQ CQ (CDR CQ))
	       (GO Sl)))
	(SETQ AA (CONS (CDR Queue) AA))
	(COND ((CDDR (RPLACD Queue (CDR Waiting)))
	       (RPLACD Waiting (CDDR Waiting))
	       (GO Ml)))
	(RETURN (CONS (CDR Queue) AA)) ))


% The dual graph is a cone (and thus connected) iff there is a Groebner basis
% element with LeadMon dividing cMon, which is NOT among the pairs found.

%# ConeP (puremon, laugmon) : bool ;
(DE ConeP (pmon lmon)
 (PROG	(AA)
	(SETQ AA (CDR GBasis))
  Ml	(COND ((AND (MONFACTORP (PMon (CAR AA)) pmon)
		    (NOT (MEMQ (CAR AA) lmon)))
	       (RETURN AA)) % OR any other non-NIL value.
	      ((SETQ AA (CDR AA))
	       (GO Ml))) ))

% Pick out the monomial which points to the polynomial with least
% polpriority. Presently this means the shortest polynomial (i.e.,
% the one with the lowest # of non-vanishing monomials).

%# MinMon (laugmon) : augmon ;
(DE MinMon (lmon)
  (COND ((NOT (CDR lmon))
	 (CAR lmon))
	(T (PROG (AA BB)
		 (SETQ AA (CAR lmon))
		 (SETQ BB (CDR lmon))
	    Ml	 (COND ((LESSP (redPriority (Mpt (CAR BB)))
			       (redPriority (Mpt AA)))
			(SETQ AA (CAR BB))))
		 (COND ((SETQ BB (CDR BB))
			(GO Ml)))
		 (RETURN AA) ))))



		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		%%%				%%%
		%%% New Groebner basis element	%%%
		%%% strategy modifications	%%%
		%%%				%%%
		%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%  There may be some strategy or rather substrategy actions taken when
% new Gbe's are found. Most simply, there may be a limit on the number
% of expected Gbe's of the current degree, e.g. by Hilbert series
% considerations.


(SETQ NewGbeStrategies!*
      (CONS '(ORDINARY . ORDNGBESTRATEGY)
	     (CONS '(NONE . ORDNGBESTRATEGY)
		    (CONS '(NIL . ORDNGBESTRATEGY)
			   (CONS '(MINHILBLIMITS . MINHILBLIMITSTRATEGY)
				  NewGbeStrategies!*)))))



%	Auxiliaries for various strategies.


%  Added 2002-07-11: /JoeB
%  Clear the remaining 'critical pairs' at the current degree.

%# CLEARCDEGREEOBSTRUCTIONS () : - ;
(DE CLEARCDEGREEOBSTRUCTIONS ()
 (PROGN	(COND ((AND !*CUSTSHOW (DEFP 'CUSTCLEARCDEGOBSTRDISPLAY))
	       (CUSTCLEARCDEGOBSTRDISPLAY)))
	(MAPC cSPairs
	      (FUNCTION (LAMBDA (mn) (PutMpt mn NIL))))
	(SETQ cSPairs NIL)
	(SETQ SP2r NIL) ))

%  Clear ALL the remaining 'input' at the current degree.

%# CLEARCDEGREEGKINPUT () : - ;
(DE CLEARCDEGREEGKINPUT ()
 (PROGN	(COND ((AND !*CUSTSHOW (DEFP 'CUSTCLEARCDEGDISPLAY))
	       (CUSTCLEARCDEGDISPLAY)))
	(SETQ cInPols NIL)
	(MAPC cSPairs
	      (FUNCTION (LAMBDA (mn) (PutMpt mn NIL))))
	(SETQ cSPairs NIL)
	(SETQ SP2r NIL) ))




%	Ordinary strategy.


%  FindNewcDeg intervener. Binary number argument, whose bits tell
% which of cInPols and cSPairs were set.
%  Note that NIL return value causes immediate return from GROEBNERKERNEL.

%# ordFixNcDeg (binno) : gendegno ;
(DE ordFixNcDeg (binno)
 (COND	((AND !*CUSTSTRATEGY (DEFP 'CUSTNEWCDEGFIX))
	 (CUSTNEWCDEGFIX binno))
	(T
	 cDeg)) )


%# ordnGbeStratInit () : - ;
(DE ordnGbeStratInit () (PROGN NIL))


% End-of-current-degree intervener.

%  Changes 1996-04-25, 1996-05-07: Moved FixNGbe to 'strategy'./JoeB
%  Changes 1996-04-18: Remove the argument; now communicates by means
% of NGroeb. Incorporated two NGroeb changing lines from GROEBNERKERNEL.
%  Moved Critical Pairs finding to DEnSPairs./JoeB

%# ordFixNGbe () : - ;
(DE ordFixNGbe ()
 (PROG	(Pek mon)
	(PutMpt (SETQ mon (APol2Lm NGroeb)) NGroeb)
	(SETQ NGroeb mon)			% NGroeb := LeadMon(NGroeb)
	(PreenRedand (Mpt mon))

% Insert mon among the other new Groebner basis element leadmons of degree
% cDeg.
	(SETQ Pek (CDDR (MonInsert mon cGBasis)))

% If we calculate PBseries simultaneously, find new Right Monomial Factors:
	(COND (!*PBSERIES
	       (FindNewRMFs mon)))
	(COND ((NOT !*IMMEDIATEFULLREDUCTION)
	       (RETURN NIL)))

% Eliminate mon from the other new Groebner basis elements with higher
% LeadMons, if demanded.
 SNgr	(COND (Pek
	       (SubtractRedor (Mpt (CAR Pek)) mon)
	       (SETQ Pek (CDR Pek))
	       (GO SNgr))) ))


%# ordStratFixcDegEnd () : - ;
(DE ordStratFixcDegEnd ()
 (PROGN	(COND ((CDR cGBasis)
	       (SETQ GBasis (NCONC GBasis (CDR cGBasis)))
	       (RPLACD cGBasis NIL)))
	(FixEndDegreeThings) ))


%# FixNcDeg (binno) : gendegno ; RESET
%# FixNGbe () : - ; RESET
%# nGbeStratInit () : - ; RESET
%# StratFixcDegEnd () : - ; RESET
%# ORDNGBESTRATEGY () : - ;
(DE ORDNGBESTRATEGY ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(COPYD 'FixNcDeg 'ordFixNcDeg)
	(COPYD 'FixNGbe 'ordFixNGbe)
	(COPYD 'nGbeStratInit 'ordnGbeStratInit)
	(COPYD 'StratFixcDegEnd 'ordStratFixcDegEnd)
	(SETQ cNGbeStrat!* 'ORDINARY)
))



%	Minimal Hilbert function values strategy.


%# hsminFixNcDeg (binno) : gendegno ;
(DE hsminFixNcDeg (binno)
 (PROG	(hf) % Hilbert function value
	(COND ((AND !*CUSTSTRATEGY (DEFP 'CUSTNEWCDEGFIX))
	       (RETURN (CUSTNEWCDEGFIX binno)))
	      ((NOT (SETQ hf (GETHSERIESMINIMUM cDeg)))
	       (SETQ MaxNewcGbes!&!* NIL)
	       (RETURN cDeg))
	      ((EQ hf 'IGNORECDEG)
	       (CLEARCDEGREEGKINPUT)
	       (RETURN 'IGNORECDEG))
	      ((EQ hf 'INPUTONLY)
	       (CLEARCDEGREEOBSTRUCTIONS)
	       (RETURN 'INPUTONLY))
	      ((EQ hf T)
	       (CLEARCDEGREEGKINPUT)
	       (RETURN NIL)))
	(SETQ MaxNewcGbes!&!* (DIFFERENCE (TDEGREEHSERIESOUT cDeg) hf))
	(COND (!*NONCOMMUTATIVE (REMLASTSERIESCALC)))
	(COND ((NOT (LESSP 0 MaxNewcGbes!&!*))
	       (CLEARCDEGREEGKINPUT)
	       (RETURN 'IGNORECDEG)))
	(RETURN T) ))


%  Initial Hilbert series, with empty partial Groebner basis:

%# hsminnGbeStratInit () : - ;
(DE hsminnGbeStratInit ()
 (CALCPOLRINGHSERIES (GETVARNO)) )


%  If we have already found as many new Gbe's as we may by the given
% Hilbert series estimate, then interrupt calculation at this degree
% by emptying the lists cInPol and cSPairs. (This action should perhaps
% rather be done by a separate function?)
%  If the customer wishes (e.g.) to have statistics, then he/she should
% turn on CUSTSHOW and define HSERIESMINCRITDISPLAY.

%# hsminFixNGbe () : - ;
(DE hsminFixNGbe ()
 (PROG	(Pek mon)
	(COND ((NUMBERP MaxNewcGbes!&!*)
	       (COND ((NOT (LESSP 0 (SETQ MaxNewcGbes!&!*
					  (SUB1 MaxNewcGbes!&!*))))
		      (COND ((AND !*CUSTSHOW (DEFP 'HSERIESMINCRITDISPLAY))
			     (HSERIESMINCRITDISPLAY)))
		      (CLEARCDEGREEGKINPUT)))))
	(PutMpt (SETQ mon (APol2Lm NGroeb)) NGroeb)
	(SETQ NGroeb mon)			% NGroeb := LeadMon(NGroeb)
	(PreenRedand (Mpt mon))

% Insert mon among the other new Groebner basis element leadmons of degree
% cDeg.
	(SETQ Pek (CDDR (MonInsert mon cGBasis)))

% If we calculate PBseries simultaneously, find new Right Monomial Factors:
	(COND (!*PBSERIES
	       (FindNewRMFs mon)))
	(COND ((NOT !*IMMEDIATEFULLREDUCTION)
	       (RETURN NIL)))

% Eliminate mon from the other new Groebner basis elements with higher
% LeadMons, if demanded.
 SNgr	(COND (Pek
	       (SubtractRedor (Mpt (CAR Pek)) mon)
	       (SETQ Pek (CDR Pek))
	       (GO SNgr))) ))


%  If new Gbe's were found at the current degree, then we should recalculate
% the Hilbert series before joining the new Gbe's to the old ones.

%# hsminStratFixcDegEnd () : - ;
(DE hsminStratFixcDegEnd ()
 (PROGN	(COND ((CDR cGBasis)
	       (SETQ GBasis (NCONC GBasis (CDR cGBasis)))
	       (RPLACD cGBasis NIL)
	       (CALCRATHILBERTSERIES)))
	(FixEndDegreeThings) ))


%# MINHILBLIMITSTRATEGY () : - ;
(DE MINHILBLIMITSTRATEGY ()
 (PROG	(!*USERMODE !*REDEFMSG)
	(COPYD 'FixNcDeg 'hsminFixNcDeg)
	(COPYD 'nGbeStratInit 'hsminnGbeStratInit)
	(COPYD 'FixNGbe 'hsminFixNGbe)
	(COPYD 'StratFixcDegEnd 'hsminStratFixcDegEnd)
	(SETQ cNGbeStrat!* 'MINHILBLIMITS)
))


%# MINHILBNGBESTRATEGY () : - ; ALIAS
(COPYD 'MINHILBNGBESTRATEGY 'MINHILBLIMITSTRATEGY)


(COND ((NOT cNGbeStrat!*)
       (ORDNGBESTRATEGY)))


%# CHECKINTERRUPTSTRATEGY (any) : boolean ;
(DE CHECKINTERRUPTSTRATEGY (uip)
 (ASSOC (COND ((ATOM uip) uip)
	      (T (CAR uip)))
	NewGbeStrategies!*) )


%# SETINTERRUPTSTRATEGY (any) : - ; FEXPR
(DF SETINTERRUPTSTRATEGY (arrg)
 (PROG	(aa) % New strategy invoking identifier / maker pair.
	(COND ((AND (PAIRP arrg) (CDR arrg))
	       (ERROR 99
		      (PROGN (PRIN2 "***** ")
			     (PRIN2 arrg)
			     "bad input to SETINTERRUPTSTRATEGY")))
	      ((NOT (SETQ aa (CHECKINTERRUPTSTRATEGY arrg)))
	       (ERROR 99
		      (PROGN (PRIN2 "***** ")
			     (PRIN2 (COND ((ATOM arrg) arrg)
					  (T (CAR arrg))))
			     "not valid new gbe strategy"))))
	(RETURN (APPLY (CDR aa) NIL)) ))


%# GETINTERRUPTSTRATEGY () : id ;
(DE GETINTERRUPTSTRATEGY () (PROGN cNGbeStrat!*))


(ON RAISE)
